;Written by Xiaoming Hu, Penn State, July 27, 2009 
; contact yuanfangcan@gmail.com
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_code.ncl"   
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_csm.ncl"   
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/contributed.ncl"

begin
  file_site = "PARat16_5.txt"
  PARdata = readAsciiTable(file_site,25,"float",2)
  printVarSummary(PARdata)

    a4_height = 29.7 ; in centimeters, if my 
    a4_width = 23.0 ; reference is correct 
    cm_per_inch = 2.54 
  res1                       = True            ; plot mods desired
  res1@gsnFrame  = False 
  res1@vpXF             = 0.25
  res1@gsnPaperHeight        = a4_width/cm_per_inch 
  res1@gsnPaperWidth        =  60/cm_per_inch 
  res1@gsnPaperMargin    = 0.01
  res1@tiXAxisString         = "PAR, umol m ~S~-2 ~N~s~S~-1"; "PM~B~2.5~N~, ~F33~m~F~g m~S~-3"      ; label bottom axis with units
  res1@tiYAxisString         = "Height, m"; "PM~B~2.5~N~, ~F33~m~F~g m~S~-3"      ; label bottom axis with units
  res1@xyDashPatterns    = (/0,0,0,0,0/)
  res1@xyLineColors           = (/"green","Purple4","blue","red","Turquoise3","Purple4","Magenta2","red","brown"/)
  res1@xyMarkLineModes   = (/"Lines","Lines","Lines","Lines","Lines"   /)
  res1@xyMarkers         =  (/16,16/)                      ; choose type of marker  
  res1@xyMarkerColor     = "Cyan3"       
  res1@xyMarkerSizeF     = 0.0115  
  res1@xyLineThicknessF       = 5 
  res1@pmLegendSide           = "Top"               ; Change location of
;  res1@pmLegendParallelPosF   = 0.17                  ; move units right
;  res1@pmLegendOrthogonalPosF = -0.5                ; move units down
  res1@pmLegendParallelPosF   = 0.79                  ; move units right
  res1@pmLegendOrthogonalPosF = -0.96                ; move units down
  res1@pmLegendWidthF         = 0.14                ; Change width and
  res1@pmLegendHeightF        = 0.15               ; height of legend.
  res1@tiXAxisFuncCode = "~"
;  res1@trXMinF = 0 
;  res1@trXMaxF = 25.0
;  res1@trYMinF = 0
;  res1@trYMaxF = 3500
  res1@gsnLeftString          = "observed SW=311Wm~S~-2 ~N~at 16.5LT"
  res1@lgPerimOn=False
  res1@lgLabelFontHeightF = 0.0205
  res1@pmTickMarkDisplayMode = "Always"         ; turn on tickmarks
  res1@tmXTOn = False            ; turn off top   labels
  res1@tmYROn = False            ; turn off right labels
  figurename = "PARprofileat16_5LT"
  wks = gsn_open_wks("eps" ,figurename)          ; eps,pdf,x11,ncgm,eeps
      gsres               = True
      gsres@gsMarkerIndex = 16          ; circle at first
      gsres@gsMarkerThicknessF = 1
      gsres@gsMarkerSizeF = 0.012
  colors = (/"white","black","Red","RoyalBlue","LightSkyBlue",\
             "PowderBlue","lightseagreen","PaleGreen","Wheat","Brown",\
             "Pink"/)
  plot = gsn_csm_xy(wks,transpose(PARdata(:,5:14)),PARdata(:,1),res1)
  system("convert -trim -resize 100% "+figurename+".eps ./figures/"+figurename+".jpg")

  gamma_L=(/0.778,0.577,0.388,0.265,0.198,0.173,0.158,0.138,0.123,0.113,0.104/)
    figurename = "gammaL_profileat16_5LT"
  res1@tiXAxisString         = "gamma_light"; "PM~B~2.5~N~, ~F33~m~F~g m~S~-3"      ; label bottom axis with units
  wks = gsn_open_wks("eps" ,figurename)          ; eps,pdf,x11,ncgm,eeps
  plot = gsn_csm_xy(wks,gamma_L,PARdata(:,1),res1)
  system("convert -trim -resize 100% "+figurename+".eps ./figures/"+figurename+".jpg")


;  res1@tmXBStyle = "Log"
  res1@trXLog= True 
  figurename = "Frarea_profileat16_5LT"
  res1@tiXAxisString         = "frarea(fraction)"; "PM~B~2.5~N~, ~F33~m~F~g m~S~-3"      ; label bottom axis with units
  wks = gsn_open_wks("eps" ,figurename)          ; eps,pdf,x11,ncgm,eeps
  plot = gsn_csm_xy(wks,transpose(PARdata(:,15:24)),PARdata(:,1),res1)
  system("convert -trim -resize 100% "+figurename+".eps ./figures/"+figurename+".jpg")

 end 

 



