load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_code.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_csm.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/contributed.ncl"
begin
       species = "PAN"
       system("mv fort.661 PAN_time_height.txt")
       PAN_contain = readAsciiTable("PAN_time_height.txt",41,"float",1)
       PAN = transpose(PAN_contain(1:,1:40))
       PAN!0 = "height"
       PAN!1 = "time"
       PAN&height =  PAN_contain(0,1:40) 
       PAN&time = PAN_contain(1:,0) 
  
  dims = dimsizes(PAN)
  do itime = 8,  dims(1)-1
  res                = True 
  res@gsnDraw     = False
  res@gsnFrame    = False
  res@trYMaxF = 4000
  res@gsnMaximize = True
  res@gsnPaperOrientation   = "portrait"
  res@vpXF           = .3            ; set the X-axis NDC starting point
  res@vpWidthF       = .45             ; set the width of the plot in NDC units
  res@vpHeightF       = .3             ; set the width of the plot in NDC units
  res@gsnSpreadColors = True
  res@tmXTOn                 = False
  res@tmYROn                 = False
  res@tmXBMode = "Explicit"
  res@tmXBValues     = ispan(24,114,6) ;(/6,12,18,24,30,36,42,42+6,42+12,18,24,30,36,42/)       ; location of explicit labels
  res@tmXBLabels     = (/"J15","06","12","18","J16","06","12","18","J17","06","12","18","J18","06","12","18"/)

  res@tiMainFontColor = "Blue" 
  res@tiXAxisFontColor = "Blue" 
  res@tiYAxisFontColor = "Blue" 
  res@tmBorderLineColor = "Blue"
  res@tmXBLabelFontColor = "Blue"
  res@tmBorderThicknessF = 4 
  res@tmYLLabelFontColor = "Blue"
  res@tmYLLabelFont = 22 
  res@tmXBLabelFont = 22 
  res@tmXBMajorLineColor = "Blue"
  res@tmYLMajorLineColor = "Blue"
;  res@tmXBLabelFontHeightF  = 0.04
  res@lbOrientation           = "vertical"
  res@tiYAxisString         = "~F22~Height, m";"SDN of T, K"; "PM~B~2.5~N~, ~F33~m~F~g m~S~-3"      ; label bottom axis with units
;  res@tiXAxisString         = "~F22~ Central Standard Time (CST)"; "PM~B~2.5~N~, ~F33~m~F~g m~S~-3"      ; label bottom axis with units
;  res@tiXAxisString         = "~F22~ Time"; "PM~B~2.5~N~, ~F33~m~F~g m~S~-3"      ; label bottom axis with units
  res@cnFillOn              = True             ; color plot desired
  res@cnLinesOn             = False            ; turn off contour lines
  res@gsnAddCyclic = False   
  res@cnLineLabelsOn        = False            ; turn off contour labels
;  res@cnFillMode = "RasterFill"
;  res@cnLevelSelectionMode  = "ManualLevels"
;  res@cnMaxLevelValF        = 65 ;1580
;  res@cnMinLevelValF       =  5 ;1420
;  res@cnLevelSpacingF   = 5 
  res@lbLabelStride         =2
;  res@lbLabelAutoStride    = True
   res@gsnLeftString = "~F22~PAN (ppb)"
   res@gsnRightString = "Simulated by CACHE"

   res@gsnYAxisIrregular2Linear = True
;  res@gsnLeftString = " ";  species(ispecies); "~F22~CurrentSpecies (ppb)"
;   res@gsnRightString = " ";"OR1 (Deciduous)"
  plres                  = True
  plres@gsLineColor      = "black"
  plres@gsLineThicknessF = 4.0

  plot = new(2,graphic)
  if (itime.lt.10) then 
  figurename = species+"_time_height_plusprofile_00"+itime
  end if  
  if (itime.ge.10.and.itime.lt.100) then 
  figurename = species+"_time_height_plusprofile_0"+itime
  end if
  if (itime.ge.100) then 
  figurename = species+"_time_height_plusprofile_"+itime
  end if 
  wks = gsn_open_wks("eps",figurename) 
  setvalues wks            
    "wkColorMap"        : "BlAqGrYeOrRevi200"  
    "wkForegroundColor" : "Blue" 
;    "wkBackgroundColor" : (/1.,1.,1./) 
  end setvalues
  gsn_define_colormap(wks,"BlAqGrYeOrRevi200")
    plot(0)  = gsn_csm_contour(wks, PAN, res )          ; draw second plot
    dummy = gsn_add_polyline  (wks, plot(0), (/16+itime/2.0,16+itime/2.0/), (/0,4000/), plres)
  res1=res
  res1@vpWidthF              = 0.85
  res1@vpHeightF       = .4
  res1@vpXF             = 0.2
   res1@tiXAxisString         = "PAN, ppb"
   res1@xyLineThicknessF       = 5
   res1@trXMaxF = 1.0 
   res1@trXMinF = 0.0 
   res1@tmXBMode = "Automatic"
   delete(res1@gsnRightString)
   delete(res1@gsnLeftString)
    plot(1) = gsn_csm_xy(wks, PAN(:,itime),PAN&height,res1)
 resP                 = True
 resP@gsnPanelYWhiteSpacePercent = 0
 resP@gsnPanelXWhiteSpacePercent = 0

     gsn_panel(wks,plot,(/2,1/),resP)  
;  draw(plot)
;  frame(wks)

 
   system("convert -trim "+figurename+".eps figures/"+figurename+".jpg")
   system("rm "+figurename+".eps")
   print("finished itime "+itime)
  end do ; itime = 0, dims(1)-1

end
;  res@lgLabelStride  =  3 
