;Written by Xiaoming Hu, Penn State, Jan, 2010 
; contact yuanfangcan@gmail.com
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_code.ncl"   
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/contributed.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_csm.ncl"   
load "$NCARG_ROOT/lib/ncarg/nclscripts/wrf/WRF_contributed.ncl"

begin
  system("./mov")
  var_names = (/"fAPI","fLIM","fISO","fMACR"/)
  var_names_show = (/"APi flux","Lim flux","Iso flux","fMACR"/)
  data_array =  readAsciiTable("Fluxes.txt",12,"float",3)
  dims = dimsizes(data_array)

  do ivars = 0 , dimsizes(var_names)-1-1

    a4_height = 29.7 ; in centimeters, if my 
    a4_width = 23.0 ; reference is correct 
    cm_per_inch = 2.54 
 
  res1                       = True            ; plot mods desired
;  res1@mpShapeMode  = "FreeAspect"
  res1@vpHeightF             =0.3
  res1@vpWidthF              = 0.65 
  res1@vpXF             = 0.2
;  res1@vpYF              =-0.9

;  res1@gsnPaperHeight        = a4_height/cm_per_inch 
;  res1@gsnPaperWidth        = a4_width/cm_per_inch  
  res1@gsnPaperHeight        = a4_width/cm_per_inch 
  res1@gsnPaperWidth        =  60/cm_per_inch 
;  res1@gsnPaperOrientation       = "landscape"
;  res1@gsnMaximize       = True
  res1@trXMinF           =  17;  190.   
;  res1@trXMaxF           =  200; 207 
  if (var_names(ivars).eq."fISO") then 
  res1@trYMaxF           =   4 
  end if 
;  res1@trYMinF           =   0 
  res1@gsnPaperMargin    = 0.01
  res1@tiYAxisString         = var_names_show(ivars)+", nmol m~S~-2~N~ s~S~-1" 
;  res1@tiXAxisString         = "Time (hours)"; "PM~B~2.5~N~, ~F33~m~F~g m~S~-3"      ; label bottom axis with units
;  res1@pmLegendDisplayMode    = "Always"       ; create a legend
;  res1@xyExplicitLegendLabels = leg            ; explicit labels created above
  res1@xyDashPatterns    = (/0,16,0,16,0,4/)       ; 0 is default (solid)
;  res1@xyLineColors           = (/"black","green","blue","Turquoise3","Purple4","Magenta2","red","brown"/)
;  res1@xyMarkLineModes   = (/"MarkLines","MarkLines","MarkLines","MarkLines","MarkLines","MarkLines"   /)
  res1@xyMarkLineModes   = (/"Markers","Markers","Markers","Markers","Markers","Markers"   /)
 res1@xyMarkers         =  (/16,16,16,16,16,16/)                      ; choose type of marker  
; res1@xyMarkerColor     = "Turquoise3"       
 res1@xyLineColors       = (/"red","black","green","blue","Purple4","Turquoise3","Purple4","Magenta2","red","brown"/)
 res1@xyMarkerColors     = (/"red","black","green","blue","Purple4","Turquoise3","Purple4","Magenta2","red","brown"/) ;"black"; "Cyan3"       
 res1@xyMarkerSizeF     = 0.01  
  res1@xyLineThicknessF       = 5 
  res1@pmLegendSide           = "Top"               ; Change location of
  res1@pmLegendParallelPosF   = .68                  ; move units right
  res1@pmLegendWidthF         = 0.4                ; Change width and
  res1@pmLegendHeightF        = 0.18                ; height of legend.
  res1@tiXAxisFuncCode = "~"
;  res1@tmYLMode = "Manual"
;  res1@trYMinF = 294.0 
  res1@trXMaxF = 120.0
;  res1@tmYLTickStartF= 294.0
;  res1@tmYLTickEndF  = 304.0
  res1@tmYLTickSpacingF = 2.0
  res1@pmTickMarkDisplayMode = "Always"         ; turn on tickmarks
  res1@tmXTOn = False            ; turn off top   labels
  res1@tmYROn = False            ; turn off right labels
  res1@lgPerimOn = False
  res1@lgLabelFontHeightF = 0.0205
  res1@pmLegendSide           = "Top"               ; Change location of
  res1@pmLegendParallelPosF   = .8                  ; move units right
  res1@pmLegendOrthogonalPosF = -0.03
  res1@pmLegendWidthF         = 0.1                ; Change width and
  res1@pmLegendHeightF        = 0.08                ; height of legend.
  res1@tmXBMode = "Explicit"
  res1@tmXBValues     = ispan(24,114,6) ;(/6,12,18,24,30,36,42,42+6,42+12,18,24,30,36,42/)       ; location of explicit labels
  res1@tmXBLabels     = (/"J15","06","12","18","J16","06","12","18","J17","06","12","18","J18","06","12","18"/)
  res1@tmXBMinorOn = False 
  res1@tmYLMinorOn = False 

  res1@pmLegendDisplayMode    = "Always"       ; create a legend
;  res1@xyExplicitLegendLabels = (/"z=22","z=36.3"/)
  res1@xyExplicitLegendLabels = (/"Potential","Actual at 22 m"/)

 figurename = "TS_CACHEsimulated_flux_"+var_names(ivars)
  wks = gsn_open_wks("eps" ,figurename)          ; eps,pdf,x11,ncgm,eeps
  setvalues wks
;    "wkColorMap"        : "BlAqGrYeOrRevi200"
    "wkForegroundColor" : "Black";"Blue"
;    "wkBackgroundColor" : (/1.,1.,1./)
  end setvalues

  res2 = True 
  res2@tiYAxisString         = "Escape efficiency" 
  res2@gsnLeftString          = "Simulated by CACHE" ;+  vars(ivar)  
  res2@xyLineThicknessF       = 5
  res2@xyLineColors       = "blue" 
  res2@tmYRMinorOn = False 
  res2@tiYAxisFontColor = "blue"
  res2@tmYRLabelFontColor = "blue"
  
;  res1@gsnRightString          = "July15-18"
  if (var_names(ivars).eq."fMACR") then 
   print("will plot MACR")
  plot  = gsn_csm_xy (wks,data_array(:,0),transpose(data_array(:,ivars*3+1:ivars*3+2)),res1) ; create plot
  else 
;  plot  = gsn_csm_xy (wks,data_array(:,0),transpose(data_array(:,ivars*3+1:ivars*3+2)),res1) ; create plot
    efficiency = data_array(:,ivars*3+2:ivars*3+2)/data_array(:,ivars*3+1:ivars*3+1)
    printVarSummary(data_array(:,0))
    printVarSummary(efficiency)
  plot  = gsn_csm_xy2 (wks,data_array(:,0),transpose(data_array(:,ivars*3+1:ivars*3+2)),transpose(efficiency),res1,res2) ; create plot
 
  end if 

  system("convert -trim -resize 100% "+figurename+".eps ./figures/"+figurename+".jpg")
  system("mv "+figurename+".eps ./figures/.")
  print("finish plotting "+var_names(ivars))
  end do ; ivars
  delete(data_array)

 end 

