;Written by Xiaoming Hu, Penn State, Jan, 2010 
; contact yuanfangcan@gmail.com
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_code.ncl"   
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/contributed.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_csm.ncl"   
load "$NCARG_ROOT/lib/ncarg/nclscripts/wrf/WRF_contributed.ncl"

begin
  system("./mov")
  var_names = (/"Limonene","API"/)
  do ivars = 0 , 0 ;dimsizes(var_names)-1

   do itime= 0, 208 
  LocalTime = ((16*2+itime)%48)/2
  day = ((16*2+itime)/48)
  data_array =  readAsciiTable("contributionstoloss"+var_names(ivars)+".txt",5,"float",(/43*itime+3,(208-itime)*43/))
  
  dims = dimsizes(data_array)

    a4_height = 29.7 ; in centimeters, if my 
    a4_width = 23.0 ; reference is correct 
    cm_per_inch = 2.54 
 
  res1                       = True            ; plot mods desired
;  res1@mpShapeMode  = "FreeAspect"
;  res1@vpHeightF             =0.3
;  res1@vpWidthF              = 0.75 
;  res1@vpXF             = 0.2
;  res1@vpYF              =-0.9

;  res1@gsnPaperHeight        = a4_height/cm_per_inch 
;  res1@gsnPaperWidth        = a4_width/cm_per_inch  
  res1@gsnPaperHeight        = a4_width/cm_per_inch 
  res1@gsnPaperWidth        =  60/cm_per_inch 
;  res1@gsnPaperOrientation       = "landscape"
;  res1@gsnMaximize       = True
;  res1@trXMinF           =  196;  190.   
  res1@trYMaxF           =   70 
  res1@trYMinF           =   0 
  res1@gsnPaperMargin    = 0.01
  res1@tiYAxisString         = "Height, m";var_names(ivars)+", ppb" 
  res1@tiXAxisString         = "Contribution to Lim degradation, /";"Time (hours)"; "PM~B~2.5~N~, ~F33~m~F~g m~S~-3"      ; label bottom axis with units
;  res1@pmLegendDisplayMode    = "Always"       ; create a legend
;  res1@xyExplicitLegendLabels = leg            ; explicit labels created above
  res1@xyDashPatterns    = (/0,16,0,16,0,4/)       ; 0 is default (solid)
;  res1@xyLineColors           = (/"black","green","blue","Turquoise3","Purple4","Magenta2","red","brown"/)
;  res1@xyMarkLineModes   = (/"MarkLines","MarkLines","MarkLines","MarkLines","MarkLines","MarkLines"   /)
  res1@xyMarkLineModes   = (/"Markers","Markers","Markers","Markers","Markers","Markers"   /)
 res1@xyMarkers         =  (/16,16,16,16,16,16/)                      ; choose type of marker  
; res1@xyMarkerColor     = "Turquoise3"       
 res1@xyLineColors       = (/"red","black","green","blue","Purple4","Turquoise3","Purple4","Magenta2","red","brown"/)
 res1@xyMarkerColors     = (/"red","black","green","blue","Purple4","Turquoise3","Purple4","Magenta2","red","brown"/) ;"black"; "Cyan3"       
 res1@xyMarkerSizeF     = 0.02  
  res1@xyLineThicknessF       = 5 
  res1@pmLegendSide           = "Top"               ; Change location of
  res1@pmLegendWidthF         = 0.4                ; Change width and
  res1@pmLegendHeightF        = 0.18                ; height of legend.
  res1@tiXAxisFuncCode = "~"
;  res1@tmYLMode = "Manual"
;  res1@trYMinF = 294.0 
  res1@trXMaxF = 1.0
;  res1@trXMinF = 16.0
;  res1@tmYLTickStartF= 294.0
;  res1@tmYLTickEndF  = 304.0
  res1@tmYLTickSpacingF = 2.0
  res1@pmTickMarkDisplayMode = "Always"         ; turn on tickmarks
  res1@tmXTOn = False            ; turn off top   labels
  res1@tmYROn = False            ; turn off right labels
  res1@lgPerimOn = False
  res1@lgLabelFontHeightF = 0.021
  res1@pmLegendSide           = "Top"               ; Change location of
  res1@pmLegendParallelPosF   = .7                  ; move units right
  res1@pmLegendOrthogonalPosF = -0.28                ; move units down
  res1@pmLegendWidthF         = 0.1                ; Change width and
  res1@pmLegendHeightF        = 0.12                ; height of legend.
;  res1@tmXBMode = "Explicit"
;  res1@tmXBValues     = ispan(24,114,6) ;(/6,12,18,24,30,36,42,42+6,42+12,18,24,30,36,42/)       ; location of explicit labels
;  res1@tmXBLabels     = (/"J15","06","12","18","J16","06","12","18","J17","06","12","18","J18","06","12","18"/)
 
  res1@pmLegendDisplayMode    = "Always"       ; create a legend
;  res1@xyExplicitLegendLabels = (/"z=2","z=8","z=14","z=18","z=26"/)
  res1@xyExplicitLegendLabels = (/"NO3","O3","OH"/)

 figurename = "TS_contr_"+var_names(ivars)+"_time"+itime
  wks = gsn_open_wks("eps" ,figurename)          ; eps,pdf,x11,ncgm,eeps
  setvalues wks
;    "wkColorMap"        : "BlAqGrYeOrRevi200"
    "wkForegroundColor" : "Black";"Blue"
;    "wkBackgroundColor" : (/1.,1.,1./)
  end setvalues

  res1@gsnLeftString          = "Simulated at "+LocalTime +"LT Day "+  day;+  vars(ivar)  
;  res1@gsnRightString          = "July15-18"
  plot  = gsn_csm_xy (wks,transpose(data_array(:,1:3)),data_array(:,0),res1) ; create plot

  system("convert -trim -resize 100% "+figurename+".eps ./figures/contributionfromradicals/"+figurename+".jpg")
  system("mv "+figurename+".eps ./figures/contributionfromradicals/.")
  print("finish plotting "+var_names(ivars))
  delete(data_array)
    print("finish time "+ itime)
   end do ; itime
  end do ; ivars
 
 end 

