      subroutine wprofil(vg,alphab,wind)
c Wind profile (roughly based on Baldocchi, 1988)

      implicit double precision (a-h,o-z)

      parameter (nlev=40,nsoil=15)    ! number of levels  
      dimension wind(nlev)
      common/height/z(nlev),zf(nlev),dz(nlev),dzf(nlev)
      common /cpy/ hcpy,htr,tlai,levcpy,levhtr,zrough,sizelf

      ustara=vg/30.
      uh=ustara*dlog((z(levcpy+1)-0.8*hcpy)/zrough)/0.4 !estimate    

c ######### For test purposes you may modify the paramters of the wind profile
      do lev=1,nlev
c     if(z(lev).ge.0.7*hcpy) then
      if(z(lev).ge.0.95*hcpy) then
c     wind(lev)=ustara*dlog((z(lev)-0.7*hcpy)/zrough)/0.4
      wind(lev)=ustara*dlog((z(lev)-0.85*hcpy)/zrough)/0.4
      else
      wind(lev)=uh*exp(-alphab*(1.-z(lev)/(hcpy)))  
c     wind(lev)=uh*exp(-alphab*((hcpy-z(lev))/(hcpy-htr)))
      endif
c     wind(levcpy)=0.2*wind(levcpy+1)+0.8*wind(levcpy-1)
      enddo
      wind(1)=0.

      write(06,*) 'uh,wind(2)',uh,wind(2)

c Test for (practically) bare soil
      if(tlai.le.0.05) then
      do lev=1,nlev
      if(lev.ne.1) 
     &wind(lev)=ustara*dlog((z(lev))/ 0.01 )/0.4
      enddo
      endif

      return
      end



      subroutine sinks(vcp,akh,lprin)
c Sinks due to deposition (Wesely, 1989, Gaoi et al., 1993)
      implicit double precision (a-h,o-z)
      parameter (nlev=40)    ! number of levels
      parameter (nspec=77, nrect=237)
      parameter(maxrect=500)
 
      logical lprin
      dimension vcp(nlev,nspec), phot1(23,nlev),
     &vp(nlev),wind(nlev),akh(nlev),photout(23,nlev)
      common/height/z(nlev),zf(nlev),dz(nlev),dzf(nlev)
      common/atmo1/ t(nlev),theta(nlev),p(nlev),rhoair(nlev)
     & ,relh(nlev)
      common /cpy/ hcpy,htr,tlai,levcpy,levhtr,zrough,sizelf
      common/resis1/rhleaf(99),rsleaf(10,99),rsnovp(10,99),
     & rst(10,99),hpsi
      common /rad2/dstrad(3,10,99),dstnet(10,99),frarea(10,99)
     &,templf(10,99),tsoil
      common/rad4/d(3,99),u(3,99),bmflx(3,99),rnet(99),rndiv(99),
     &tsfc,rnlam(3,99)
      common/misc2/fr(99),ct(99),totlai,df(99)
     &,clai(99),distls(10),itot,itotp1,jtot
 
       dimension shilf(99,nspec)
       dimension henry(nspec),f0(nspec),dfakt(nspec)
 
      common/quellen/source(nlev,nspec)
      common/cpysrc/ evaps(99),heats(99)

      common/spezies/
     &    LACO3, LADDC, LADDT, LADDX, LALD , LAPI , LAPIP, LCH4,
     &    LCO  , LCO2 , LCSL , LCSLP, LDCB , LDIEN, LETE , LETEP,
     &    LETH , LETHP, LGLY , LH2  , LH2O , LH2O2, LHC3 , LHC3P,
     &    LHC5 , LHC5P, LHC8 , LHC8P, LHCHO, LHKET, LHNO3, LHNO4,
     &    LHO  , LHO2 , LHONO, LISO , LISOP, LKET , LKETP, LLIM,
     &    LLIMP, LMACR, LMGLY, LMO2 , LN2  , LN2O5, LNO  , LNO2,
     &    LNO3 , LO1D , LO2  , LO3  , LO3P , LOLI , LOLIP, LOLND,
     &    LOLNN, LOLT , LOLTP, LONIT, LOP1 , LOP2 , LORA1, LORA2,
     &    LPAA , LPAN , LPHO , LSO2 , LSULF, LTCO3, LTOL , LTOLP,
     &    LTPAN, LUDD , LXO2 , LXYL , LXYLP

 

c NH3 fehlt noch  (Henry=1.04e4) 
c--------------------------------------------------------------
       data henry/
c        ACO3    ADDC    ADDT    ADDX   ALD    API    APIP   CH4
     & 11.4,   1.e-22, 1.e-22, 1.e-22,  11.4,  4.76e-3,4.76e-3,1.50E-3,
c       CO     CO2     CSL     CSLP    DCB     DIEN    ETE    ETEP
     & 8.2e-3, 1.86e-1,4.0e5,  1.e-22, 1.4e6,  4.76e-3,4.7e-3,1.e-22,
c       ETH     ETHP   GLY     H2      H2O     H2O2    HC3    HC3P
     & 2.0e-3, 1.e-22, 1.4e6,  1.e-22, 1.e-22, 7.45e4,1.42e-3,1.e-22, 
c       HC5    HC5P    HC8     HC8P    HCHO   HKET   HNO3    HNO4
     & 1.13e-3,1.e-22, 1.42e-3,1.e-22,22970., 7.80E+3,2.69e13,2.0e13,
c       HO     HO2     HONO    ISO     ISOP    KET     KETP    LIM
     & 1.e-22, 1.e-22, 3.47e5, 4.76e-3,4.76e-3,33.0,   33.0,   4.74e-3,
c       LIMP    MACR   MGLY    MO2     N2      N2O5    NO      NO2
     & 4.74e-3,11.4,   3.71e3, 1.e-22, 1.e-22, 1.0e20, 1.9e-3, 0.0064,
c       NO3    O1D     O2      O3      O3P    OLI     OLIP    OLND
     & 15.0,   1.e-22, 1.e-22, 0.0113,1.e-22, 1.35e-3,1.35e-3,1.e-22,
c       OLNN   OLT     OLTP    ONIT    OP1    OP2     ORA1   ORA2
     & 1.e-22, 4.76e-3,4.76e-3, 1.13,  221.,  1.68e6, 9.85e6,9.63e5,
c        PAA    PAN     PHO     SO2    SULF    TCO3    TOL     TOLP
     &   473.,  2.97,   1.e-22, 2.53e5,1.e+20, 1.e-22, 0.151,  1.e-22,
c       TPAN   UDD     XO2     XYL     XYLP
     &  2.97,  1.40e+6,1.e-22, 0.145,  1.e-22/

c ########## f0 can be modified for test purposes #################
       data f0/
c       ACO3    ADDC    ADDT    ADDX   ALD     API     APIP   CH4
     &  1.0,   0.0,    0.0,    0.0,    0.0,    0.0,    0.0,    0.0,
cc   &  1.0,   0.0,    0.0,    0.0,    1.0,    0.0,    0.0,    0.0,
c---------------------------------------------------------
c       CO     CO2     CSL     CSLP    DCB     DIEN    ETE    ETEP
     &  0.0,   0.0,    0.0,    0.0,    0.0,    0.0,    0.0,   0.0, 
c       ETH    ETHP    GLY     H2      H2O     H2O2    HC3    HC3P
     &  0.0,   0.0,    0.0,    0.0,    0.0,    1.0,    0.0,    0.0,
c       HC5    HC5P    HC8     HC8P    HCHO    HKET   HNO3    HNO4
cc   &  0.0,   0.0,    0.0,    0.0,    0.0,    0.0,   0.0,    0.0,  
     &  0.0,   0.0,    0.0,    0.0,    1.0,    0.0,   0.0,    0.0,  
c---------------------------------------------------------
c       HO     HO2     HONO    ISO     ISOP    KET     KETP    LIM
     &  1.0,   1.0,    0.1,    0.0,    0.0,    0.0,    0.0,    0.0,
cc   &  1.0,   1.0,    0.1,    0.0,    0.0,    1.0,    1.0,    0.0,
c       LIMP   MACR    MGLY    MO2     N2      N2O5    NO      NO2
     &  0.0,   1.0,    0.0,    0.0,    0.0,    1.0,    0.0,    0.1, 
cc   &  0.0,   0.0,    0.0,    0.0,    0.0,    1.0,    0.0,    0.1, 
c---------------------------------------------------------
c       NO3    O1D     O2      O3      O3P     OLI     OLIP    OLND
c    &  1.0,   0.0,   0.0,   0.0001,   0.0,    0.0,    0.0,    0.0,  
     &  1.0,   0.0,   0.0,   1.0000,   0.0,    0.0,    0.0,    0.0,  
c                        ------------------
c       OLNN   OLT     OLTP    ONIT    OP1     OP2     ORA1   ORA2
     &  0.0,    0.0,    0.0,    0.0,   0.1,    0.1,    0.0,   0.0,
c        PAA    PAN     PHO     SO2    SULF    TCO3    TOL     TOLP
     &   0.1,   0.1,    0.0,   0.0,    1.0,    0.0,    0.0,    0.0,
c       TPAN   UDD     XO2     XYL     XYLP
     &  0.1,   0.0,    0.0,    0.0,    0.0/

       data dfakt /     ! D_H2O/Dspec  D_H2O=.228cm^2/s 
c       ACO3    ADDC    ADDT    ADDX   ALD    API    APIP   CH4
     &  2.0,   2.3,    2.2,    2.3,    1.6,    2.6,    2.6,    0.9,
c       CO     CO2     CSL     CSLP    DCB     DIEN    ETE    ETEP
     &  1.2,   1.5,    2.4,    2.4,    2.1,    1.7,    1.9,   1.9,
c       ETH    ETHP    GLY     H2      H2O     H2O2    HC3    HC3P
     &  1.2,   1.2,    1.7,    0.2,    1.0,    1.4,    1.5,    1.5,
c       HC5    HC5P    HC8     HC8P    HCHO    HKET   HNO3    HNO4
     &  1.9,   1.0,    2.4,    2.5,    1.3,    2.0,   1.92,   2.14,
c       HO     HO2     HONO    ISO     ISOP    KET     KETP    LIM
     &  1.0,   1.3,    1.58,   1.9,    1.9,    2.0,    1.9,    2.6,
c       LIMP   MACR    MGLY    MO2     N2      N2O5    NO      NO2
     &  2.6,   1.9,    1.9,    1.0,    0.9,    2.2,    1.32,   1.646,
c       NO3    O1D     O2      O3      O3P    OLI     OLIP    OLND
     &  1.8,    1.0,    1.0,   1.4,    1.0,    1.9,    1.9,    1.5,
c       OLNN   OLT     OLTP    ONIT    OP1     OP2     ORA1   ORA2
     &  1.5,    1.5,    1.5,    2.5,   1.6,    1.8,    1.6,   1.8,
c        PAA    PAN     PHO     SO2    SULF    TCO3    TOL     TOLP
     &   2.0,   2.66,   1.0,    1.9,   0.2,    1.8,    2.3,    2.3,
c       TPAN   UDD     XO2     XYL     XYLP
     &  2.8,   2.5,    1.0,    2.4,    2.4/

 
      rcutref=2000. 
      rcutref=3000. 

c     sink strength in  1/sec
c
      do k=1,nlev
       do igas=1,nspec
       shilf(k,igas)=0.
       enddo
      enddo

      do j=2,jtot      ! Bezug auf die Schichten
      k=levhtr-2+j
      f0(lo3)=1.0    
c     if(relh(k).gt.0.50) 
c    & f0(lo3)=1.-0.9*(relh(k)-0.50)/(0.999-0.50)
       f0(lo3)=1.-0.9*relh(k)
c -------------------------------------------
       do igas=1,nspec
       rbl=rhleaf(j)/dfakt(igas)  !Gao et al., 1993 (JGR 98, 18339 ...)
       rmeso=1./(henry(igas)/3000. + 100.*f0(igas)) 
       rcut=rcutref/(henry(igas)*1.e-5 + f0(igas)) 
       condf=0.0
       do i=1,itotp1
c      rstij=min(3000.,rst(i,j))
c      cond=1./(rbl+rstij*dfakt(igas)+rmeso)+
       cond=1./(rbl+rst(i,j)*dfakt(igas)+rmeso)+
     &    2./(rbl+rcut)
       condf=condf+frarea(i,j)*cond
!       if(igas.eq.lald .and.i.eq.itotp1) ! itotp1)
!     & write(06,'("i,j,rbl,rmeso,rcut,rst ",2i3,8e12.4)') 
!     & i,j,rbl,rmeso,rcut,rst(i,j),cond,frarea(i,j),condf
       enddo
 
       shilf(levhtr-2+j,igas)=condf*df(j-1)/dz(j+levhtr-3)
c      if(igas.eq.lhno3)
c    & write(06,'("j,k,shilf",2i3,5e12.4)') j,k,
c    & condf,df(j-1),dz(j+levhtr-3),shilf(levhtr-2+j,igas),
c    & vcp(k,igas)
       enddo
       enddo

c  'Quellstaerke' pro m**3
      do k=2,nlev
       do ls=1,nspec
       si=-0.5*(shilf(k,ls)+shilf(k-1,ls))*vcp(k,ls)
       source(k,ls)= source(k,ls)+si
       enddo
 
      if(lprin.and.k.le.25)
     &write(06,'("sink O3, HNO3",i3,3e12.4)') k,source(k,52),
     &   source(k,31),0.5*(shilf(k,31)+shilf(k-1,31))*vcp(k,31)
      enddo

c Deposition am Boden nach Gao
       rgs=500.
       rgo=200.
      f0(lo3)=1.0

      if(relh(1).gt.0.80) then
       rgo=200.+1800.*(relh(1)-0.80)/(0.999-0.80)
       f0(lo3)=1.-0.9*(relh(1)-0.80)/(0.999-0.80)
      endif

       do ls=1,nspec
       rgi=1./(henry(ls)*1.e-5/rgs + f0(ls)/rgo)
       ra0=z(2)/max(1.e-4,akh(1))
       sh1=1./(ra0+rgi)
       si=-sh1*vcp(1,ls)/dz(1)
       if(ls.eq.lo3 ) write(06,'("rgi,ra0"5e12.4)') rgi,ra0,
     &  henry(ls)*1.e-5/rgs,f0(ls)/rgo   
       source(1,ls)= source(1,ls)+si
       enddo

      return
      end
 


