c Subroutines sources and sourcneu by Renate Forkel, IMK-IFU
c Leaf energy balnce subroutines are from CUPID (John M. Norman, Department of Soil Science,
c University of Wisconsin-Madison, http://www.soils.wisc.edu/~norman/cupid/outline.html)
c ---------------------------------------------------------------------------------

      subroutine cpstruct(imunu,gr)
      implicit double precision (a-h,o-z)
c leaf angle distribution
      common /cpy/ hcpy,htr,tlai,levcpy,levhtr,zrough,sizelf
      common/deg/sunazm,viewzn(99),viewaz(99),nozenv,noazmv
     & ,xintv(20,90)
      common/astron/eqtm,decl,sindec,cosdec,decmax,sinlat,coslat,
     1 tanlat,dlong
      common/indax3/xmeuaz,xneuaz,beta0,fraz(99),fradeg(360),nbeta
      common/misc1/pi,pid180,pid2,sigma,iwrite(9,99),kmax
      common/misc2/fr(99),ct(99),totlai,df(99)
     &,clai(99),distls(10),itot,itotp1,jtot
      common/misc6/xint,xintz(99),nalpha,ispher,nxintz
      common /rad1/emis,emisol,rsoil(3),rleaf(3),tleaf(3),aleaf(3)
     &,expdif(99),rlayr(3,30),tlayr(3,30)
      common /rad2/dstrad(3,10,99),dstnet(10,99),frarea(10,99)
     &,templf(10,99),tsoil
      common/rad4/d(3,99),ui(3,99),bmflx(3,99),rnet(99),rndiv(99),
     & tsfc,rnlam(3,99)
      common/rad6/rlfdif(3),tlfdif(3),rlfdir(3),tlfdir(3)
      common/rad8/rlfhem(3,9),tlfhem(3,9)
      dimension gr(99),frdeg(91),theta(99),ca(9),sa(9)
c
c  input coefficients of parabola describing hemispherical refl and tran
c    as a func of source inc angle(a*x**2 + b*x + c = refl) for vis and
c    nir. other wavebands interpolated from these. c=normal inc value.
      read(20,*)avisr,bvisr,cvisr,anirr,bnirr,cnirr
      read(20,*)avist,bvist,cvist,anirt,bnirt,cnirt
      nxintz=9
      read(20,*)ispher,nalpha,(gr(l),l=1,nalpha)
      read(20,*)imunu,xmeu,xneu

      do 15 k=1,kmax
 15   aleaf(k)=1.-rleaf(k)-tleaf(k)
c
c*****  cupradazm insert begin 2: leaf reflectance/transmittance *******
c  Chen, 8/30/89.
c
c  input coefficients of parabola describing hemispherical refl and tran
c    as a func of source inc angle(a*x**2 + b*x + c = refl) for vis and
c    nir. other wavebands interpolated from these. c=normal inc value.
c  interpolate a,b,and c coeff for leaf refl and trans dep on source inc
      do 26 k=1,kmax
      do 26 i=1,itot
      angl=90./itot*(i-1)+90./(2.*itot)
      ar=anirr-(cnirr-rleaf(k)*100.)*(anirr-avisr)/(cnirr-cvisr)
      br=bnirr-(cnirr-rleaf(k)*100.)*(bnirr-bvisr)/(cnirr-cvisr)
      cr=rleaf(k)*100.
      rlfhem(k,i)=(ar*angl*angl+br*angl+cr)/100.
c  rlfhem is used with angle betw leaf normal and sun from light dist.
      at=anirt-(cnirt-tleaf(k)*100.)*(anirt-avist)/(cnirt-cvist)
      bt=bnirt-(cnirt-tleaf(k)*100.)*(bnirt-bvist)/(cnirt-cvist)
      ctr=tleaf(k)*100.
      tlfhem(k,i)=(at*angl*angl+bt*angl+ctr)/100.
c       write(6,*)'k,i,rlfhem,tlfhem=',k,i,rlfhem(k,i),tlfhem(k,i)
c  if refl +tran of leaf > 1 then reduce trans.
      if(rlfhem(k,i)+tlfhem(k,i).gt.1.)tlfhem(k,i)=1.-rlfhem(k,i)
 26   continue
c  calc sums to get weighted leaf refl and trans for diffuse inc rad.
      do 101 ialpha=1,itot
      alpha=pid2*(ialpha-1)/(itot) + pi/(4.*itot)
      sa(ialpha)=sin(alpha)
      ca(ialpha)=cos(alpha)
 101  continue
      do 400 k=1,kmax
      sum2=0.
      sum3=0.
      sum4=0.
      do 300 iangl=1,itot
      angl=pid2*(iangl-1)/itot + pid2/(2.*itot)
      sum2=sum2+sa(iangl)*ca(iangl)
      sum3=sum3+rlfhem(k,iangl)*sa(iangl)*ca(iangl)
      sum4=sum4+tlfhem(k,iangl)*sa(iangl)*ca(iangl)
 300  continue
      rlfdif(k)=sum3/sum2
      tlfdif(k)=sum4/sum2
 400  continue


c   calc area fraction of leaves in each leaf angle class for
c   spherical leaf angle distrib.
      delthe=pi/(2.*itot)
      theta(1)=delthe*.5
      ct(1)=cos(theta(1))
      fr2=cos(delthe)
      fr(1)=1.-fr2
      fr1=fr2
      do  100 i=2,itot
      im1=i-1
      theta(i)=theta(im1)+delthe
      ct(i)=cos(theta(i))
      fr2=cos(i*delthe)
      fr(i)=fr1-fr2
      fr1=fr2
 100  continue

      if(nalpha.ne.itot) write(6,123)itot,nalpha
 123  format(' itot= ',i3,' nalpha= ',i3)
      if(ispher.ne.0) goto 180
      if(imunu.eq.1) goto 185
      if(imunu.eq.2) angmn=xmeu
c      if(imunu.eq.2)ang2m=xneu
c above was commented and following two added by Chen, 7/6/89.
	if(imunu.eq.2) angsd=xneu
	if(imunu.eq.2) ang2m=angmn*angmn+angsd*angsd
      if(imunu.eq.2) goto 176
      sum=0.
      do 160 i=1,nalpha
 160  sum=sum+gr(i)
      do 170 i=1,nalpha
 170  fr(i)=gr(i)/sum
      itot=nalpha
      goto172
c  set nalpha=itot so leaf angle classes are consistent
 180    do 171 ixintz=1,nxintz
 171    xintz(ixintz)=.5
      nalpha=itot
c
c  calc 1 st and 2 nd moments to fit beta dist to fr(i) for input dist
c    or spherical.
 172  sum1=0.
      sum2=0.
      do 175 i=1,nalpha
      alpha= 90./(2.*itot) + (i-1)*90./itot
      sum1=sum1+fr(i)*alpha
      sum2=sum2+fr(i)*alpha**2
 175  continue
      angmn=sum1
      ang2m=sum2
      angsd=sqrt(ang2m-angmn**2)
 176  xneu=(1.-ang2m/(90.*angmn))/(ang2m/angmn**2 -1.)
      xmeu=xneu*(90./angmn - 1.)
 185  continue
c  set nalpha=itot so leaf angle classes are consistent
      nalpha=itot
      read(20,*) imunua,xmeuaz,xneuaz,beta0,nbeta
	if (ispher.eq.0 .and. imunua.ne.0) goto 194
	  xmeuaz=1.
	  xneuaz=1.
	  beta0=0.
	  angamn=180.
	  angasd=103.92
	  goto 196
 194    if (imunua.ne.2) goto 196
	  angamn=xmeuaz
	  angasd=xneuaz
	  anga2m=angamn*angamn+angasd*angasd
	  xneuaz=(1.-anga2m/(360.*angamn))/(anga2m/angamn**2-1.)
	  xmeuaz=xneuaz*(360./angamn-1.)
 196    continue
c ----------------------------------------------------------------------
      call lad(xmeu,xneu,fr,itot,gamrat,frdeg)
c ----------------------------------------------------------------------
	if (ispher.eq.1) goto 198
	  if (imunu.ne.1) goto 197
	    angmn=0.
	    ang2m=0.
	    do 186 i=1,nalpha
	    alpha=(90./nalpha)*(i-.5)
	    angmn=angmn+alpha*fr(i)
 186        ang2m=ang2m+alpha*alpha*fr(i)
	    angmn=angmn/nalpha
	    ang2m=ang2m/nalpha
	    angsd=sqrt(ang2m-angmn*angmn)
 197      if (imunua.ne.1) goto 198
	    angamn=0.
	    anga2m=0.
	    do 187 i=1,nbeta
	    beta=(360./nbeta)*(i-.5)
	    angamn=angamn+beta*fraz(i)
 187        anga2m=anga2m+beta*beta*fraz(i)
	    angamn=angamn/nbeta
	    anga2m=anga2m/nbeta
	    angasd=sqrt(anga2m-angamn*angamn)
 198    continue

c following 17 statements calculates extinction coefficient at nxintz
c zeniths averaged over azimuth, xintz(iz). Chen, 05/25/89.
	if (ispher.eq.1) goto 290
	wz=pi/2/nxintz
	wbeta=2*pi/nbeta
	do 211 iz=1,nxintz
	thetas=wz*(iz-.5)
	if (abs(xmeuaz-1.+xneuaz-1.).gt.0.0001) goto 263
c ----------------------------------------------------------------------
	call simpsn(thetas,0.,fr,nalpha,xintz(iz))
c ----------------------------------------------------------------------
	goto 211
 263    suma=0.
	do 220 iphi=1,nbeta
	phi=wbeta*(iphi-.5)
c ----------------------------------------------------------------------
	call simpsn(thetas,phi,fr,nalpha,xxint)
c ----------------------------------------------------------------------
 220    suma=suma+xxint
	xintz(iz)=suma/nbeta
 211    continue
 290    continue
c       write(6,*)'xintz(i)=',(xintz(i),i=1,nxintz)
c calculation of extinction coef. in viewing directions, xintv(.,.)
c follow. Chen, 9/19/89.
      do 270 ithetv=1,nozenv
      do 280 iphiv=1,noazmv
      xintv(ithetv,iphiv)=0.5
      if(ispher.eq.1) goto 280
      thetv=viewzn(ithetv)*pid180
      phiv=viewaz(iphiv)*pid180
c ----------------------------------------------------------------------
      call simpsn(thetv,phiv,fr,nalpha,xintv(ithetv,iphiv))
c ----------------------------------------------------------------------
 280  continue
 270  continue
      return
      end 



      subroutine sources(vcp,lprin)
c Old BVOC emission routine, follwing Guenther et al. 'plant type' equal 1 or 2 in input file
      implicit double precision (a-h,o-z)
      parameter (nlev=40)    ! number of levels  
      parameter (nspec=77, nrect=237)
      parameter(maxrect=500)

      logical lprin
      common/height/z(nlev),zf(nlev),dz(nlev),dzf(nlev)
      common/atmo1/ t(nlev),theta(nlev),p(nlev),rhoair(nlev)
     & ,relh(nlev)
      common /cpy/ hcpy,htr,tlai,levcpy,levhtr,zrough,sizelf
      common /rad2/dstrad(3,10,99),dstnet(10,99),frarea(10,99)
     &,templf(10,99),tsoil
      common/rad4/d(3,99),u(3,99),bmflx(3,99),rnet(99),rndiv(99),
     &tsfc,rnlam(3,99)
      common/misc2/fr(99),ct(99),totlai,df(99)
     &,clai(99),distls(10),itot,itotp1,jtot
      common/efact/ efiso,efterp,efovoc,reflai,
     & splitterp(3),splitovoc(9)

      common/etc/fiso,fapi,flim,fmacr,sumsiso,sumsapi,sumslim,fapi2
     &,fiso2,flim2,fmacr2
       dimension vcp(nlev,nspec)
       dimension gammat(10,99),gammatl(99) ! ,gammata(20),gammair(20)
       dimension gammal(10,99),gammall(99)
       dimension gammt(10,99),gammatt(99)
       dimension shilfi(99),shilft(99),shilfo(99),
     & sourcli(99),sourclt(99),sourclo(99)

      common/quellen/source(nlev,nspec)
      common/cpysrc/ evaps(99),heats(99)

      common/spezies/
     &    LACO3, LADDC, LADDT, LADDX, LALD , LAPI , LAPIP, LCH4,
     &    LCO  , LCO2 , LCSL , LCSLP, LDCB , LDIEN, LETE , LETEP,
     &    LETH , LETHP, LGLY , LH2  , LH2O , LH2O2, LHC3 , LHC3P,
     &    LHC5 , LHC5P, LHC8 , LHC8P, LHCHO, LHKET, LHNO3, LHNO4,
     &    LHO  , LHO2 , LHONO, LISO , LISOP, LKET , LKETP, LLIM,
     &    LLIMP, LMACR, LMGLY, LMO2 , LN2  , LN2O5, LNO  , LNO2,
     &    LNO3 , LO1D , LO2  , LO3  , LO3P , LOLI , LOLIP, LOLND,
     &    LOLNN, LOLT , LOLTP, LONIT, LOP1 , LOP2 , LORA1, LORA2,
     &    LPAA , LPAN , LPHO , LSO2 , LSULF, LTCO3, LTOL , LTOLP,
     &    LTPAN, LUDD , LXO2 , LXYL , LXYLP

      
       do k=1,nlev
       do jspec=1,nspec
       source(k,jspec)=0.
       enddo
       enddo

c  water vapor from lfebal 
      do k=2,nlev-1
      alam=(597.-0.57*(t(k)-273.15))*4.18e03
       source(k,lh2o)=0.5*(evaps(k)+evaps(k-1))/alam/dz(k) 
       source(k,lh2o)=source(k,lh2o)/rhoair(k)/0.622
c     if(k.le.levcpy) 
c    &write(06,'("sh2o",i3,e12.4)') k,source(k,lh2o)
      enddo


c     source strength in  1/sec

c ISO
        fluxa=0.
      do j=2,jtot      ! Bezug auf die Schichten            
       gammatl(j)=0.
       gammall(j)=0.
       gammatt(j)=0.
       shilfi(j)=0.
       shilft(j)=0.
       shilfo(j)=0.

       do i=1,itotp1
c Isoprene emission, factor C_T (temperature)
       gammat(i,j)=gammct(templf(i,j))  !templf refers to layers
c Isoprene emission, factor C_L (light)
       gammal(i,j)=gammcl(dstrad(1,i,j))
c Terpene and OVOC correction factor (temperature)
       gammt(i,j)=gammtf(templf(i,j))

       gammatl(j)=gammatl(j)+gammat(i,j)*frarea(i,j)
       gammall(j)=gammall(j)+gammal(i,j)*frarea(i,j)
       gammatt(j)=gammatt(j)+gammt(i,j)*frarea(i,j)
       enddo
c      if(gammall(j).gt.1000.) then
c      write(06,'("gammt",i3,10e12.4)') j,(gammt(i,j),i=1,itotp1)
c      write(06,'("frarea",i3,10e12.4)') j,(frarea(i,j),i=1,itotp1)
c      write(06,'(" g*f  ",i3,12e12.4)') j,gammatt(j),
c    & (frarea(i,j)*gammt(i,j),i=1,itotp1)
c      endif

c  efiso: Source strength per m**3 referring to  1m**2 leaf/m**2 ground           
c       if(j.lt.jtot-4) then
c       efisoh=20*efiso
c       else
c       efisoh=.5*efiso
c       endif
       shilfi(j)=efiso *df(j-1)
       if (j.ge.6) then 
          shilfi(j)=efiso *df(j-1)/10000000.   ! Loblolly Pine doesn't emit isoprene
!x          print*, "Loblolly Pine doesn't emit isoprene"
       end if 
       shilfi(j)=shilfi(j)*gammatl(j)*gammall(j)
                              ! df refers to the layers, however the index starts at 1
                              ! Emission per layer
c a-pinene
       shilft(j)=efterp*df(j-1)        
       if (j.le.6) then
         shilft(j)=efterp*df(j-1)/5.0 !Sweet gum has lower rate       
       end if 
       fluxa=fluxa+shilft(j)
       shilft(j)=shilft(j)*gammatt(j)             

c OVOC
       shilfo(j)=efovoc*df(j-1)       
       shilfo(j)=shilfo(j)*gammatt(j)                           

       if(lprin) then
c      if(gammall(j).gt.0.) then
      write(06,'("shilf",i3,8e12.4)') j,shilfi(j),shilft(j),
     & gammatl(j),gammall(j),gammatt(j),df(j-1)
c      endif
       endif
      enddo

      fluxa=fluxa/12. ! Mittelwert

      do k=1,nlev
      sourcli(k)=0.
      sourclt(k)=0.
      sourclo(k)=0.
      enddo

      do j=2,jtot
      sourcli(levhtr-2+j)=shilfi(j)
      sourclt(levhtr-2+j)=shilft(j)
      sourclo(levhtr-2+j)=shilfo(j)
      enddo
c

c  Source strength in m**3            
c   potential isoprene source strength 
      sumsiso=0.
      sumsapi=0.
      sumslim=0.
      do k=2,nlev   
c        source(k ,liso)=0.001e-9   ! 3.6 ppb/h 
c      source(k,liso)=0.5*(sourcl(k)+sourcl(k-1))/(z(levcpy)-z(levhtr))
c  ls=36 !ISO
       source(k,liso)=0.5*(sourcli(k)+sourcli(k-1))

c Split of terpenes accordung to W.Seidl (priv. comm.)

c API represents alpha-Pinene, beta-Pinen, 3Carene and Sabinene
c LIM represents Limonen, alpha-Terpinene, beta-Terpinene, 
c                 alpha-Phellandrene and beta-Phellandrene
c P-Cymene is represented by XYL
c M. Kuhn, priv. comm., Feb. 1998

       sterp=0.5*(sourclt(k)+sourclt(k-1))
c     ls=6    !API
        source(k,lapi)=splitterp(1)*sterp
      sumsapi=sumsapi+source(k,lapi)*0.5*(dz(k)+dz(k-1))  


c     ls=36   !ISO
        source(k,liso)=source(k,liso)+splitterp(2)*sterp
      sumsiso=sumsiso+source(k,liso)*0.5*(dz(k)+dz(k-1))  
c     ls=40   !LIM
        source(k,llim)=splitterp(3)*sterp
      sumslim=sumslim+source(k,llim)*0.5*(dz(k)+dz(k-1))  

c Split of OVOC    
       sovoc=0.5*(sourclo(k)+sourclo(k-1))
c     ls=23   !HC3
        source(k,lhc3)=splitovoc(1)*sovoc
c     ls=25   !HC5
        source(k,lhc5)=splitovoc(2)*sovoc
c     ls=58   !OLT
        source(k,lolt)=splitovoc(3)*sovoc
c     ls=54   !OLI
        source(k,loli)=splitovoc(4)*sovoc
c     ls=29   !HCHO
        source(k,lhcho)=splitovoc(5)*sovoc
c     ls=5    !ALD
        source(k,lald)=splitovoc(6)*sovoc
c     ls=38   !KET
        source(k,lket)=splitovoc(7)*sovoc
c     ls=63   !ORA1
        source(k,lora1)=splitovoc(8)*sovoc
c     ls=64   !ORA2
        source(k,lora2)=splitovoc(9)*sovoc


      if(lprin.and.k.le.25) 
     &write(06,'("siso,sapi",i3,8e12.4)') k,source(k,liso),
     &   source(k,lapi)
      enddo

      write(06,'("sumapi",8e12.4)') sumsapi*1.e9*5.44,
     &             fluxa*1.e9*5.44*20.
      write(06,'("sumsiso, sumsapi",2e12.4)') 
     &   sumsiso*1.e9*40., sumsapi*1.e9*40.
c
c  NO source at surface   ! ###########  Adapt, if necessary
      ft=exp(0.071*(t(1)-273.15))
      source(1,lno)= 0.0125e-12/dzf(1)*ft  
c     source(1,lno)= 0.125e-12/dzf(1)*ft  


      return
      end


 
      subroutine sourcneu(vcp,isortin,lprin,deltim)
c New BVOC emission routine, follwing Steinbrecher, 'plant type' greater than 2 in input file

c                                          3 resp 1: Fichte (spruce)
c                                          4 resp 2: Kiefer (pine)
c                                          5 resp 3: Eiche  (oak)
c                                          6 resp 4: Eiche (Ciccioli) (oak)
c                                          7 resp 5: Orange
c                                          8 resp 6: Quercus Robur (oak)
c                                          9 resp 8: Oak ridge deciduous mixed forest
c Monoterpenes are considered seperately with pool and synthesis term.
c However, afterwards, they are all put into the group TERP 

      implicit double precision (a-h,o-z)
      parameter (nlev=40)    ! number of levels  
      parameter (nspec=77, nrect=237)
      parameter(maxrect=500)

      logical lprin

      common/spezies/
     &    LACO3, LADDC, LADDT, LADDX, LALD , LAPI , LAPIP, LCH4,
     &    LCO  , LCO2 , LCSL , LCSLP, LDCB , LDIEN, LETE , LETEP,
     &    LETH , LETHP, LGLY , LH2  , LH2O , LH2O2, LHC3 , LHC3P,
     &    LHC5 , LHC5P, LHC8 , LHC8P, LHCHO, LHKET, LHNO3, LHNO4,
     &    LHO  , LHO2 , LHONO, LISO , LISOP, LKET , LKETP, LLIM,
     &    LLIMP, LMACR, LMGLY, LMO2 , LN2  , LN2O5, LNO  , LNO2,
     &    LNO3 , LO1D , LO2  , LO3  , LO3P , LOLI , LOLIP, LOLND,
     &    LOLNN, LOLT , LOLTP, LONIT, LOP1 , LOP2 , LORA1, LORA2,
     &    LPAA , LPAN , LPHO , LSO2 , LSULF, LTCO3, LTOL , LTOLP,
     &    LTPAN, LUDD , LXO2 , LXYL , LXYLP


      common/height/z(nlev),zf(nlev),dz(nlev),dzf(nlev)
      common/atmo1/ t(nlev),theta(nlev),p(nlev),rhoair(nlev)
     & ,relh(nlev)
      common /cpy/ hcpy,htr,tlai,levcpy,levhtr,zrough,sizelf
      common /rad2/dstrad(3,10,99),dstnet(10,99),frarea(10,99)
     &,templf(10,99),tsoil
      common/rad4/d(3,99),u(3,99),bmflx(3,99),rnet(99),rndiv(99),
     &tsfc,rnlam(3,99)
      common/misc2/fr(99),ct(99),totlai,df(99)
     &,clai(99),distls(10),itot,itotp1,jtot
      common/efact/ efiso,efterp,efovoc,reflai,
     & splitterp(3),splitovoc(9)
      common/efactneu/ efiso2(2,15),                   !Isopren
     & efapi(2,15),efbpi(2,15),efcam(2,15),eftri(2,15),  !Monoterpene
     & efsab(2,15),efmyr(2,15),efbph(2,15),eflim(2,15),
     & ef18c(2,15),efd3c(2,15),efpci(2,15),efaty(2,15),
     & efaca(2,15),efbca(2,15),efoci(2,15),
     & sovoce(9)
      common/etc/fiso,fapi,flim,fmacr,sumsiso,sumsapi,sumslim,fapi2
     &,fiso2,flim2,fmacr2
      data rneta/99999./,drnet/0.0/

       dimension vcp(nlev,nspec)
       dimension gammat(10,99),gammats(99) ! ,gammata(20),gammair(20)
       dimension gammal(10,99),gammals(99)
       dimension gammt(10,99),gammatp(99)
       dimension shilfi(99),shilft(99),shilfl(99),shilfh(99),shilfo(99),
     & shilfd(99),
     & sourcli(99),sourclt(99),sourcll(99),sourclh(99),sourclo(99)
     & ,sourcld(99)

c                  HC3  HC5  OLT  OLI  HCHO  ALD  KET  ORA1 ORA2
       data sovoce/0.08,0.05,0.06,0.31,0.11, 0.16,0.06,0.10,0.07/ ! Grell et al, 2000 (converted to moles)  
c      data sovoce/0.08,0.05,0.06,0.31,0.11, 0.50,0.50,0.10,0.07/ ! Grell et al, 2000 Mol, Modified ALD und KET
c                                            xxxxxxxxxx

c      data sovoce/0.64,0.02,0.04,0.08,0.025,0.11,0.02,0.05,0.05/ ! Steinbrecher, priv. comm.

      common/quellen/source(nlev,nspec)
      common/cpysrc/ evaps(99),heats(99)

      isort=isortin-2

c Emission factors for Isopren and Monoterpene ef(ii,isort)
c     ii=1: Pool, ii=2: Syntheseterm, isort: tree species
c                                      isortin  isort (isortin is the number which is specified in the input file)
c                                          3 resp 1: Fichte (spruce)
c                                          4 resp 2: Kiefer (pine)
c                                          5 resp 3: Eiche  (oak)
c                                          6 resp 4: Eiche (Ciccioli) (oak)
c                                          7 resp 5: Orange
c                                          8 resp 6: Quercus Robur (oak)
c                                          9 resp 8: Oak ridge deciduous mixed forest
c
c For isort=1 and isort=2:
c value=value given by Rainer * leaf area factor /40. * 1.e-12
c                                           1 nmol/m**3 = 0.025 ppb
c leaf area factor    = 2.74 for spruce  (Riederer et al., 1988)
c                     = 2.56 for pine    (Perterer und Koerner, 1990)
c values  in ppt*10E-12/s per (leaf area/m**2 ground per meter height difference)
c i.e. the specified values times df(k)/dz(k) result in ppb*1E-6/s
c
c  1) Picea abies, Fichte/spruce
c Numbers are in  nmol/m**2 total leaf area/s
      tfakt= 0.80
 
      fu=2.74/(40.9*t(10)/273.)*1.e-9   * tfakt 
c                      xxxxxxxxxxxxxxxxxx
      efiso2(1,1)=0.0
      efiso2(2,1)=.3415*fu /tfakt 
      efapi(1,1)=0.0
      efapi(2,1)=.519*fu
      efbpi(1,1)=.013*fu
      efbpi(2,1)=.154*fu
      efcam(1,1)=.007*fu
      efcam(2,1)=.009*fu
      eftri(1,1)=.003*fu
      eftri(2,1)=0.002*fu
      efsab(1,1)=.002*fu
      efsab(2,1)=.018*fu
      efmyr(1,1)=.012*fu *0.0
      efmyr(2,1)=.024*fu *0.0
      efbph(1,1)=.016*fu
      efbph(2,1)=0.0
      eflim(1,1)=.037*fu 
      eflim(2,1)=0.0
      ef18c(1,1)=0.0
      ef18c(2,1)=0.0
      efd3c(1,1)=0.0
      efd3c(2,1)=0.0
      efpci(1,1)=0.0
      efpci(2,1)=0.0
      efaty(1,1)=0.0
      efaty(2,1)=0.0
c
c  2) Pinus sylvestris Kiefer/pine
c Numbers are in  nmol/m**2 total leaf area/s
      fu=2.56/40.9*1.e-9 
      efiso2(1,2)=0.0
      efiso2(2,2)=0.0
      efapi(1,2)=0.079*fu
      efapi(2,2)=0.035*fu
      efbpi(1,2)=0.012*fu
      efbpi(2,2)=0.013*fu
      efcam(1,2)=0.009*fu
      efcam(2,2)=0.007*fu
      eftri(1,2)=0.
      eftri(2,2)=0.
      efsab(1,2)=0.020*fu !orig. 0.40 war zu viel
      efsab(2,2)=0.
      efmyr(1,2)=0.015*fu
      efmyr(2,2)=0.026*fu
      efbph(1,2)=0.
      efbph(2,2)=0.
      eflim(1,2)=0.011*fu
      eflim(2,2)=0.0
      ef18c(1,2)=0.
      ef18c(2,2)=0.
      efd3c(1,2)=0.075*fu
      efd3c(2,2)=0.013*fu
      efpci(1,2)=0.
      efpci(2,2)=0.
      efaty(1,2)=0.0
      efaty(2,2)=0.0
c
c  3) Quercus ilex (mediterrane Eichenart)
      fu=2.00/40.9*1.e-9  !Steinbrecher
c     fu=2.00/40.9*1.e-9/1.095*.42  !Seufert
c                         ^damit wird der Emissionsfaktor von Seufert in Relation zu dem 
c                          Emissionsfaktor fuer API von Rainer gesetzt
c                               ^ Guenthers Faktor ist aber gesamt, API ist davon nur 42%
      efiso2(1,3)=0.0
      efiso2(2,3)=0.190*fu
      efapi(1,3)=0.0          
      efapi(2,3)=3.583*fu
      efbpi(1,3)=0.
      efbpi(2,3)=1.798*fu
      efcam(1,3)=0.
      efcam(2,3)=0.255*fu
      eftri(1,3)=0.    ! ???
      eftri(2,2)=0.    ! ???
      efsab(1,3)=0.
      efsab(2,3)=1.788*fu
      efmyr(1,3)=0.
      efmyr(2,3)=0.340*fu
      efbph(1,3)=0.
      efbph(2,3)=0.
      eflim(1,3)=0.0     
      eflim(2,3)=0.307*fu
      ef18c(1,3)=0.
      ef18c(2,3)=0.378*fu
      efd3c(1,3)=0.0      
      efd3c(2,3)=0.101*fu
      efpci(1,3)=0.
      efpci(2,3)=0.
      efaty(1,3)=0.0
      efaty(2,3)=0.307*fu
c

c  4) Quercus ilex (mediterranean oak) according to  Ciccioli
c Numbers are in Micrograms per m**2 soil surface per sec
      fu=25./136. /3.5 *1.e-9 *1.31 !!!!!!!!!!!!!
      efiso2(1,4)=0.0
      efiso2(2,4)=0.010*fu
      efapi(1,4)=0.0
      efapi(2,4)=0.419*fu
      efbpi(1,4)=0.
      efbpi(2,4)=0.222*fu
      efcam(1,4)=0.
      efcam(2,4)=0.019*fu
      eftri(1,4)=0.    ! ???
      eftri(2,2)=0.001*fu    ! ???
      efsab(1,4)=0.
      efsab(2,4)=0.089*fu
      efmyr(1,4)=0.
      efmyr(2,4)=0.*fu
      efbph(1,4)=0.
      efbph(2,4)=0.023*fu
      eflim(1,4)=0.0
      eflim(2,4)=0.0*fu
      ef18c(1,4)=0.
      ef18c(2,4)=0.*fu
      efd3c(1,4)=0.0
      efd3c(2,4)=0.*fu
      efpci(1,4)=0.
      efpci(2,4)=0.028*fu
      efaty(1,4)=0.0
      efaty(2,4)=0.08*fu
c
c  5) Orange
c Numbers are in ng/m**2 proj.leafarea/s
      fu=1.0/136./40.9*1.e-9          !!!!!!!!!!!!!
      efiso2(1,5)=0.
      efiso2(2,5)=0.*fu*2
      efapi(1,5)=0.
      efapi(2,5)=0.*fu
      efbpi(1,5)=0.
      efbpi(2,5)=0.*fu
      efcam(1,5)=0.
      efcam(2,5)=0.*fu
      eftri(1,5)=0.    ! ???
      eftri(2,2)=0.*fu    ! ???
      efsab(1,5)=2.6*fu
      efsab(2,5)=0.
      efmyr(1,5)=0.
      efmyr(2,5)=0.*fu
      efbph(1,5)=0.
      efbph(2,5)=0.*fu
      eflim(1,5)=0.5*fu
      eflim(2,5)=0.
      ef18c(1,5)=0.
      ef18c(2,5)=0.*fu
      efd3c(1,5)=0.
      efd3c(2,5)=0.*fu
      efpci(1,5)=0.
      efpci(2,5)=0.*fu
      efaty(1,5)=0.0
      efaty(2,5)=0.*fu
      efaca(1,5)=0.8*fu
      efaca(2,5)=0.
      efbca(1,5)=20.*fu
      efbca(2,5)=0.
      efmyr(1,5)=0.1*fu
      efmyr(2,5)=0.
      efoci(1,5)=1.2*fu
      efoci(2,5)=0.
c
c  6) Quercus Robur
c Numbers are in nmolper m**2 proj. leaf area per sec at 25 !!! Grad C   
      fu=1./40.9*1.e-9*gammct(30.)/gammct(25.)
      efiso2(1,6)=0.
      efiso2(2,6)=16.8*fu  !!! *0. !---------------------
      efapi(1,6)=0.
      efapi(2,6)=0.
      efbpi(1,6)=0.
      efbpi(2,6)=0.
      efcam(1,6)=0.
      efcam(2,6)=0.
      eftri(1,6)=0.
      eftri(2,2)=0.
      efsab(1,6)=0.
      efsab(2,6)=0.
      efmyr(1,6)=0.
      efmyr(2,6)=0.
      efbph(1,6)=0.
      efbph(2,6)=0.
      eflim(1,6)=0.
      eflim(2,6)=0.
      ef18c(1,6)=0.
      ef18c(2,6)=0.
      efd3c(1,6)=0.
      efd3c(2,6)=0.
      efpci(1,6)=0.
      efpci(2,6)=0.
      efaty(1,6)=0.
      efaty(2,6)=0.
      efaca(1,6)=0.
      efaca(2,6)=0.
      efbca(1,6)=0.
      efbca(2,6)=0.
      efmyr(1,6)=0.
      efmyr(2,6)=0.
      efoci(1,6)=0.
      efoci(2,6)=0.
c

c  7) Oakridge mixed forest
c Numbers are in nmolper m**2 proj. leaf area per sec
      fu=1./40.9*1.e-9
      efiso2(1,7)=0.
      efiso2(2,7)=14.0*fu !!! *0. !---------------------
      efapi(1,7)=0.2*fu
      efapi(2,7)=0.2*fu

      efbpi(1,7)=0.
      efbpi(2,7)=0.
      efcam(1,7)=0.
      efcam(2,7)=0.
      eftri(1,7)=0.
      eftri(2,2)=0.
      efsab(1,7)=0.
      efsab(2,7)=0.
      efmyr(1,7)=0.
      efmyr(2,7)=0.
      efbph(1,7)=0.
      efbph(2,7)=0.
      eflim(1,7)=0.02*fu 
      eflim(2,7)=0.01*fu

      ef18c(1,7)=0.
      ef18c(2,7)=0.
      efd3c(1,7)=0.
      efd3c(2,7)=0.
      efpci(1,7)=0.
      efpci(2,7)=0.
      efaty(1,7)=0.
      efaty(2,7)=0.
      efaca(1,7)=0.
      efaca(2,7)=0.
      efbca(1,7)=0.
      efbca(2,7)=0.
      efmyr(1,7)=0.
      efmyr(2,7)=0.
      efoci(1,7)=0.
      efoci(2,7)=0.
c

       do k=1,nlev
       do jspec=1,nspec
       source(k,jspec)=0.
       enddo
       enddo

c  water vapor from lfebal 
      do k=2,nlev-1
      alam=(597.-0.57*(t(k)-273.15))*4.18e03
       source(k,lh2o)=0.5*(evaps(k)+evaps(k-1))/alam/dz(k) 
       source(k,lh2o)=source(k,lh2o)/rhoair(k)/0.622 
c     if(k.le.levcpy) 
c    &write(06,'("sh2o",i3,e12.4)') k,source(k,lh2o)
      enddo


c     source strength in  1/sec

c Group for RACM species (terp is api)
      efterpp=efapi(1,isort)+efbpi(1,isort)+efcam(1,isort)+
     &  efsab(1,isort)+ef18c(1,isort)+efd3c(1,isort)+efpci(1,isort)+
     &  efaty(1,isort)
      efterps=efapi(2,isort)+efbpi(2,isort)+efcam(2,isort)+
     &  efsab(2,isort)+ef18c(2,isort)+efd3c(2,isort)+efpci(2,isort)+
     &  efaty(2,isort)
      efisop=efiso2(1,isort)+efmyr(1,isort)
      efisos=efiso2(2,isort)+efmyr(2,isort)
      eflimp=eflim(1,isort)+efbph(1,isort)
     & +efaca(1,isort)+efbca(1,isort)
      eflims=eflim(2,isort)+efbph(2,isort)
     & +efaca(2,isort)+efbca(2,isort)
      efhc8p=eftri(1,isort)
      efhc8s=eftri(2,isort)
      efdiep=efoci(1,isort) 
      efdies=efoci(2,isort)
c  xxxxxxxxxxxxxxxxxxxxxxxx
c      efisos=0.0
c      efisop=0.0
c      eflims=0.0
c      eflimp=0.0
c  xxxxxxxxxxxxxxxxxxxxxxxx


       avdfg=0.
      do j=2,jtot      ! refers to layers
       gammats(j)=0.
       gammals(j)=0.
       gammatp(j)=0.
       shilfi(j)=0.
       shilft(j)=0.
       shilfl(j)=0.
       shilfh(j)=0.
       shilfo(j)=0.
       shilfd(j)=0.

       do i=1,itotp1
c Isoprene emission factor C_T (temperature)
       gammat(i,j)=gammct(templf(i,j))  !templf refers to layers
c Isoprene emission factor C_L (light)
       gammal(i,j)=gammcl(dstrad(1,i,j))
c Terpene and OVOC correction factor (temperature)
       gammt(i,j)=gammtf(templf(i,j))

       gammats(j)= gammats(j)+gammat(i,j)*frarea(i,j)
       gammals(j)= gammals(j)+gammal(i,j)*frarea(i,j)
       gammatp(j)= gammatp(j)+gammt(i,j)*frarea(i,j)
       enddo

c  efiso: Quellstaerke pro m**3 bezogen auf 1m**2 proj.Blatt/m**2 Boden            
       shilfi(j)=(efisop*gammatp(j) +
     &            efisos*gammats(j)*gammals(j))*df(j-1) 
                                ! df refers to layers, index starts at 1
                                ! Emission per layer
c Terpenes = a-pinene
       shilft(j)=(efterpp*gammatp(j) +
     &            efterps*gammats(j)*gammals(j))*df(j-1)
c
c Modification for Q.ilex (G. Seufert) for not light adapted leaves ##############################
       if(isort.eq.3) then
        if(j.lt.jtot-2) then
         if(j.lt.jtot-7) then
          shilft(j)=0.043*shilft(j)
          else
          shilft(j)=0.48*shilft(j)
          endif 
       endif
       endif

c Limonene
       shilfl(j)=(eflimp*gammatp(j) +
     &            eflims*gammats(j)*gammals(j))*df(j-1)

c HC8 = tricyclene
       shilfh(j)=(efhc8p*gammatp(j) +
     &            efhc8s*gammats(j)*gammals(j))*df(j-1)

c DIEN=Ocimene
       shilfd(j)=(efdiep*gammatp(j) +
     &            efdies*gammats(j)*gammals(j))*df(j-1)

c OVOC
c      efovocp=efovoc*(jtot-1)   !only Pool
c      efovocp= 9.1e-12 *(jtot-1) *.1       !only Pool
c      efovocp= 15.e-12
c Grell et al. 2000
       efovocp= 0.20 * 2.74/(40.9*t(10)/273.)*1.e-9 ! * tfakt !first Number is nmol/m**2/s total OVOC
c Steinbrecher, undefinierte Quelle
c      efovocp= 0.40 * 2.74/(40.9*t(10)/273.)*1.e-9 ! * tfakt !first Number is nmol/m**2/s total OVOC
c                ------------vorlaeufig 
       shilfo(j)=efovocp*gammatp(j)*df(j-1) 

       if(gammals(j).gt.1000.) then
c      if(lprin) then
       write(06,'("gammat",i3,10e12.4)') j,(gammat(i,j),i=1,itotp1)
       write(06,'("frarea",i3,10e12.4)') j,(frarea(i,j),i=1,itotp1)
       write(06,'(" gammal",i3,10e12.4)') j,
     & (            gammal(i,j),i=1,itotp1)
       endif

       if(lprin) then
c      if(gammals(j).gt.1000.) then
       sumdfg=gammals(j)*df(j-1)
      write(06,'("shilf",i3,12e12.4)') j,shilfi(j),shilft(j),
     & shilfl(j),shilfh(j),
     & gammats(j),gammals(j),gammatp(j)
     & ,df(j-1),gammals(j)*df(j-1)  
c      endif
       endif
      enddo


      do k=1,nlev
      sourcli(k)=0.
      sourclt(k)=0.
      sourcll(k)=0.
      sourclh(k)=0.
      sourclo(k)=0.
      sourcld(k)=0.
      enddo
      do j=2,jtot
      sourcli(levhtr-2+j)=shilfi(j)
      sourclt(levhtr-2+j)=shilft(j)
      sourcll(levhtr-2+j)=shilfl(j)
      sourclh(levhtr-2+j)=shilfh(j)
      sourclo(levhtr-2+j)=shilfo(j)
      sourcld(levhtr-2+j)=shilfd(j)   ! korrigiert 8.3.2004
c     write(06,'("sourclt",i3,12e12.4)') levhtr-2+j,sourclt(levhtr-2+j) 
      enddo
c

c  Quellstaerke pro m**3            
c   potential isoprene source strength in m         
      sumsiso=0.
      sumsapi=0.
      sumslim=0.

      do k=2,nlev   

c     ls=36   !ISO
       source(k,liso)=0.5*(sourcli(k)+sourcli(k-1))/
     &                        (0.5*(dz(k)+dz(k-1)))
      sumsiso=sumsiso+source(k,liso)*0.5*(dz(k)+dz(k-1))  

c Split of terpenes according to W.Seidl (priv. comm.)

c API represents alpha-Pinene, beta-Pinen, 3Carene and Sabinene
c LIM represents Limonen, alpha-Terpinene, beta-Terpinene, 
c                 alpha-Phellandrene and beta-Phellandrene
c P-Cymene is represented by XYL
c M. Kuhn, priv. comm., Feb. 1998

c     ls=6    !API
        source(k,lapi)=0.5*(sourclt(k)+sourclt(k-1))/
     &                        (0.5*(dz(k)+dz(k-1)))
      sumsapi=sumsapi+source(k,lapi)*0.5*(dz(k)+dz(k-1))  

c     ls=40   !LIM
        source(k,llim)=0.5*(sourcll(k)+sourcll(k-1))/
     &                        (0.5*(dz(k)+dz(k-1)))
      sumslim=sumslim+source(k,llim)*0.5*(dz(k)+dz(k-1))  

c Ocimane=DIEN
        source(k,ldien)=0.5*(sourcld(k)+sourcld(k-1))/
     &                         0.5*(dz(k)+dz(k-1))
c Split of OVOC    
        source(k,lhc8)=0.5*(sourclh(k)+sourclh(k-1))/
     &                         0.5*(dz(k)+dz(k-1))

       sovoc=0.5*(sourclo(k)+sourclo(k-1))
      ls=23   !HC3
        source(k,ls)=sovoce(1)*sovoc
      ls=25   !HC5
        source(k,ls)=sovoce(2)*sovoc
      ls=58   !OLT
        source(k,ls)=sovoce(3)*sovoc
      ls=54   !OLI
        source(k,ls)=sovoce(4)*sovoc
c       source(k,ls)= 0.0
      ls=29   !HCHO
        source(k,ls)=sovoce(5)*sovoc
        if(k.eq.15) 
     &  write(06,*) 'HCHO',k,ls,lhcho,source(k,ls),source(k,lapi)
      ls=5    !ALD
        source(k,ls)= sovoce(6)*sovoc
c       source(k,ls)=          sovoc
c  Test
c     &    +source(k,lapi)/8.
      ls=38   !KET
        source(k,ls)=sovoce(7)*sovoc 
c  Test
c    &    +source(k,lapi)/6.
      ls=63   !ORA1
        source(k,ls)=sovoce(8)*sovoc
      ls=64   !ORA2
        source(k,ls)=sovoce(9)*sovoc

c  Limonene source at ground (Orange only)
c Steinbrecher et al., 1999 (Phys. Chem. Earth, 24, 695-698)
      if(isort.eq.5.and.k.eq.2) then
c                         Seufert, ng/m**2/s   Steinbrecher
      efisos=.03*136.!     10.                   .03*136.
      efapis=0.2*136. !     20.			  0.2*136.
      eflims=.8*136.  !    410.			  .8*136.
      ftf=exp(0.09*(t(1)+5.-303.)) !Guenther et al., 1995 (JGR 100, 8878)
      ftf2=exp(0.09*(t(1)-5.-303.))
      fff=1./136. /40.9*1.e-9 /(0.5*(dz(k)+dz(k-1))) !*.5 *0.7 !for fetch
c                                             consider only half of the soil surface
      ftff=.1*ftf+.9*ftf2 !account for sunlit and shaded fraction
      source(k,liso)=source(k,liso)+efisos*fff*ftff  !myrcen
      source(k,lapi)=source(k,lapi)+efapis*fff*ftff   !a+b-pinen,d3caren,sabinen,18-cineol
      source(k,llim)=source(k,llim)+eflims*fff*ftff  !limonen
      sumsiso=sumsiso+efisos*fff*ftff*0.5*(dz(k)+dz(k-1))
      sumsapi=sumsapi+efapis*fff*ftff*0.5*(dz(k)+dz(k-1))
      sumslim=sumslim+eflims*fff*ftff*0.5*(dz(k)+dz(k-1))
      endif

c     if(lprin.and.k.eq.2) 
c    &write(06,'("siso",i3,5e12.4)') k-1,source(1,liso),
c    & source(1,lapi),source(1,llim),source(1,lhcho)
      if(lprin.and.k.le.25) 
     &write(06,'("siso",i3,5e12.4)') k,source(k,liso),
     & source(k,lapi),source(k,llim),source(k,lhcho)
      enddo

c
c  NO source at surface  ! ###########  Adapt, if necessary
      ft=exp(0.071*(t(1)-273.15))
      source(1,lno)=0.125e-12/dzf(1)*ft  !org.
      if(rneta.lt.99998.) then
      drnet=(rnet(1)-rneta)/deltim*3600. !drnet/dt in W/m**2 /h
      if(drnet.lt.0.) drnet=0.
      endif
      fts=exp(0.140*(t(1)-293.15))  ! Stefan (the value of 293 is correkt)
      source(1,lno)=0.625e-12/dzf(1)*fts + 
     &            0.02*drnet*0.125e-12/dzf(1)/0.07
c     source(1,lno)=7.e-12/dzf(1)*fts 
      rneta=rnet(1)

c use low soil NO for Oak Ridge
      ft=exp(0.071*(t(1)-273.15))
      fu=1./40.9*1.e-9
      source(1,lno)= 0.0125e-12/dzf(1)*ft
c     source(1,lno)= 0.125e-12/dzf(1)*ft  
c     source(1,lno)= fu*0.07/14./dzf(1)*ft  

      write(06,'("sumslim",4e12.4)') source(1,llim),sumslim

      return
      end





      function gammct(tlc)
c Isoprene emission, factor C_T (temperature)
      implicit double precision (a-h,o-z)
      ts=303.
      tm=314.
      r=8.314
      ctl=95000.
      ct2=230000. !Guenther et al., 1995 (JGR 100, 8878)
 
      tl=tlc+273.15
      z=exp( (ctl*(tl-ts)) / (r*ts*tl) )
      xn=0.926+exp( (ct2*(tl-tm)) / (r*ts*tl) )
      gammct=z/xn
c
      return
      end
 

      function gammcl(par)
c Isoprene emission, factor C_L (light)
      implicit double precision (a-h,o-z)
!    leaf level PPFD of the past 24 h (P24) and past 240 h (P240)
      cll=1.066     !Guenther et al., 1995 (JGR 100, 8878) 
      alpha=0.0027  !Guenther et al., 1995 (JGR 100, 8878)
!      swd240=420  ! modify if necessary xhu
!      P240 = swd240 * 4.766 * 0.5
!      swd24=520  ! modify if necessary xhu
!      P24 = swd24 * 4.766 * 0.5
!      cll=0.0468*exp(0.0005*(P24-P0)) * (P240**0.6)

!      alpha= 0.004-0.0005*log(P240)       !MEGAN 
 
      if(par.gt.1.e-8) then
      pare=par*4.6    
      z=alpha*cll*pare
      xn=sqrt(1.+alpha*alpha*pare*pare)
c                                    ^ korr. 16.3.98
      gammcl=z/xn
      else
      gammcl=0.
      endif
c
      return
      end
 
      subroutine gammcl_MEGAN(par, gam_P)
c Isoprene emission, factor C_L (light)
      implicit none 
      real :: swd240,P240,swd24,P24
      real :: cll, alpha 
      real :: pare, z, xn 
      real,parameter :: P0 = 200  ! molm-2 s-1 
      real,intent(in)  :: par  
      real,intent(out) :: gam_P 
!    leaf level PPFD of the past 24 h (P24) and past 240 h (P240)
!      cll=1.066     !Guenther et al., 1995 (JGR 100, 8878) 
!      alpha=0.0027  !Guenther et al., 1995 (JGR 100, 8878)
      swd240=120  ! modify if necessary xhu
      P240 = swd240 * 4.766 * 0.5
      swd24=120  ! modify if necessary xhu
      P24 = swd24 * 4.766 * 0.5
      cll=0.0468*exp(0.0005*(P24-P0)) * (P240**0.6)

      alpha= 0.004-0.0005*log(P240)       !MEGAN 
 
      if(par.gt.1.e-8) then
      pare=par*4.6    
      z=alpha*cll*pare
      xn=sqrt(1.+alpha*alpha*pare*pare)
c                                    ^ korr. 16.3.98
      gam_P=z/xn
      else
      gam_P=0.
      endif
c
      return
      end
 
      function gammtf(tlc)
c Terpene and OVOC correction factor (temperature)
      implicit double precision (a-h,o-z)
      ts=303.
      beta=0.09  !Guenther et al., 1995 (JGR 100, 8878)
 
      tl=tlc+273.15
      gammtf=exp(beta*(tl-ts))
c
      return
      end
 




      subroutine stoma(lprin,tair,relh)
      implicit double precision (a-h,o-z)
      parameter (nlev=40)    ! number of levels  
      common /cpy/ hcpy,htr,tlai,levcpy,levhtr,zrough,sizelf
      common/resis1/rhleaf(99),rsleaf(10,99),rsnovp(10,99),
     & rst(10,99),hpsi
      common/leaf1/delt(10,99),psilf,tran(10,99)
      common/resis2/radn,anstom,rcut20,rsmin,trsopt,trsmin,trsmax,rsm
     1,rsexp,psi1,psi2
      common /rad2/dstrad(3,10,99),dstnet(10,99),frarea(10,99)
     &,templf(10,99),tsoil
      common/misc2/fr(99),ct(99),totlai,df(99)
     &,clai(99),distls(10),itot,itotp1,jtot
      common/root1/froot(99),resrot(99),rootsm,psixy,psitop,rroot
     1,rootup(99),cpytr,psisum,aroot
      common/photo2/ox,cair,rastom,cucond,d1,bkv,facj,rxcham,rsfac
     &             ,znon,conmin,ic3c4

      logical lprin
       dimension relh(nlev)

c  cuticular resistance may be a func of temp
      rcut=rcut20
      do 1000 i=1,itotp1
      do 1000 j=2,jtot
      tl=templf(i,j)
c   calc rs vs radiation
c     write(6,*)i,j,dstrad(1,i,j)
      if(dstrad(1,i,j).gt.0.01) goto 100
      rsleaf(i,j)=rcut
      rst(i,j)=rsleaf(i,j)   ! Hier mit Cuticula !!!!
      goto 1000
 100  znum=(anstom-1.)*radn/dstrad(1,i,j)
      rsleaf(i,j)=rsmin*(znum+1.)
c     write(6,*)'rsleaf=',rsleaf(i,j),'znum=',znum,'rcut=',rcut
c  calc temp effect g(templf)
      if(templf(i,j)-trsopt) 400,400,500
 400  g=1.+(((trsopt-templf(i,j))/(trsopt-trsmin))**rsexp)*rsm
      goto 600
 500  g=1.+(((templf(i,j)-trsopt)/(trsmax-trsopt))**rsexp)*rsm
 600  continue
c  calc water pot effect hpsi
      if(psitop.ge.psi1) hpsi=1.
      if(psitop.lt.psi1) hpsi=(psitop-psi2)/(psi1-psi2)
      if(psitop.lt.psi2) hpsi=0.
      if(hpsi.lt.0.001) hpsi=0.001
      rsleaf(i,j)=rsleaf(i,j)*g/hpsi

      vsat=6.108*10**(7.5*tl/(237.3+tl))
      vpd=vsat*(1.-relh(j-1+levhtr))
c     vpd=vsat*(1.-relh(j))
      rstom=rsleaf(i,j)
      rbl=0.0 ! rx*cmo*rsfac Boundary layer resistance is assumed zero
              ! as long as some numbers are still missing
      vpds=vpd*rstom/(rstom+rbl)
      vpfac=rstom/(rstom+rbl)
      dvpds=vpds/vsat
      rsleaf(i,j)=rsleaf(i,j)*(1.+bkv*(dvpds-d1))
      rst(i,j)=rsleaf(i,j)   ! Ohne Cuticula

c  calc final resis as parallel comb of rcut and rs
      rsleaf(i,j)=rcut*rsleaf(i,j)/(rcut+rsleaf(i,j)) 
 1000 continue
      return
      end
 

      subroutine lfebal(tair,eair,wind,lprin)
      use parameters
      implicit double precision (a-h,o-z)
      parameter (nlev=40)    ! number of levels  

      logical lprin
!x      common/timpar/timloc,dt,month,jday,iyear,icumdy
      common /cpy/ hcpy,htr,tlai,levcpy,levhtr,zrough,sizelf
      common/resis1/rhleaf(99),rsleaf(10,99),rsnovp(10,99),
     &rst(10,99),hpsi
      common/photo2/ox,cair,rastom,cucond,d1,d2,facj,rxcham,rsfac
     &             ,znon,conmin,ic3c4
      common/leaf1/delt(10,99),psilf,tran(10,99)
      common/leaf2/evap(10,99),gevap(10,99),heat(10,99),gheat(10,99)
     &,alam
      common/leaf3/hwater(10,99),ghwatr(10,99)
      common /rad2/dstrad(3,10,99),dstnet(10,99),frarea(10,99)
     &,templf(10,99),tsoil
      common/misc1/pi,pid180,pid2,sigma,iwrite(9,99),kmax
      common/misc2/fr(99),ct(99),totlai,df(99)
     &,clai(99),distls(10),itot,itotp1,jtot
c     common/prof1/tair(99),eair(99),phim,phih,refhtt,refhte,relh(99)
c    &,nlabcy,nlbcpy
      common/rad1/emis,emisol,rsoil(3),rleaf(3),tleaf(3),aleaf(3),
     1expdif(99),rlayr(3,30),tlayr(3,30)
      common/cpy1/etotwt,htot,rplnt,evapg(99),heatg(99),eave(99)
     &,have(99),waterg(99)
      common/cpy2/hsoil,hcpys,evtot,etotw(99),contot(99),scond(10,99)
     1,ecpys,cphstr,cpestr,wcpys,evsmic,ihrwet(99)
      common/inter2/evint(99),evimm(99),pintmx,frstem,drip(99),stem
      common/inter1/wtp(99),frwet(99),frwtmx,pint(99),pilast(99)
     1,pint1(99),twater
       dimension tair(nlev),eair(nlev),wind(nlev),rh(99)
      REAL :: dt
      dt = deltim
c  calc leaf energy bal for each angle class and layer
      do 1100 j=2,jtot
c  tair and eair are at top of layers so ave adjacent values to get
c    layer average
c     tmean=(tair(levhtr+j)+tair(levhtr+j-1))*.5-273.15
c     emean=(eair(levhtr+j)+eair(levhtr+j-1))*.5
c     umean=(wind(levhtr+j)+wind(levhtr+j-1))*.5

      tmean=(tair(levhtr+j-1)+tair(levhtr+j-2))*.5-273.15
      emean=(eair(levhtr+j-1)+eair(levhtr+j-2))*.5
      umean=(wind(levhtr+j-1)+wind(levhtr+j-2))*.5
c xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

      if(umean.le..01) rhleaf(j)=500.
      if(umean.gt..01) rhleaf(j)=180.*sqrt(sizelf/umean) 

      sumbal=0.
      do 1000 i=1,itotp1
      iflgrs=1
      irept=0
      icond=0
      isate=0
 100  temp=templf(i,j) !!!!! (templf(i,j)+tmean)*0.5
c  sat vp calc
      estemp=6.108*10**(7.5*temp/(temp+237.3))
      estair=6.108*10**(7.5*tmean/(tmean+237.3))
c        write(6,*) 'es=',estemp,'ta=',temp,'ea=',estair,'tmean=',tmean
c
c  latent heat
      alam=597.-0.57*temp
c  slope of sat vp curve
      s=estemp*alam/(0.1103*(temp+273.15)**2)
      if(contot(j).ge.0.)goto 400
 300  isate=1
      iflgrs=0
 400  continue
c  rsleaf is for both sides of leaf  rhleaf is for one side of leaf
c  for amphistom leaves (i.e. stomata on both sides) rsfac=.5  see sub inplnt
c  for hypostom leaves rsfac=1
      if(isate.eq.1) rsfac2=.5
      if(isate.eq.0) rsfac2=rsfac
      r1=iflgrs*rsleaf(i,j)+rhleaf(j)*rsfac2
      rslst=rsleaf(i,j)
      hh=frwet(j)/(rhleaf(j)*0.5)+(1.-frwet(j))/r1 
c     approx correction for heat taken from leaf by cold irrig water
      if(pint1(j).lt..0001) twater=tair(j)
      znum=1825.*hh*(estair-emean)+1.134e-7*emis*(tmean+273.15)**4
     &+pint1(j)*4187.6*(tair(j)-twater)/(dt*df(j-1))
      den=1825.*s*hh+2400./rhleaf(j)+4.536e-7*emis*(temp+273.15)**3
     &+pint1(j)*4187.6/(dt*df(j-1))
      delt(i,j)=(dstnet(i,j)+2.*dstrad(3,i,j)-znum)/den
      if(delt(i,j).lt.-10.) delt(i,j)=-10.
      if(delt(i,j).gt.10.) delt(i,j)=10.

c     write(06,'("delt",2i3,e12.4)') i,j,delt(i,j)
      templf(i,j)=tmean+delt(i,j)
      estlf=6.108*10**(7.5*templf(i,j)/(templf(i,j)+237.3))
      if(isate.eq.1) goto 700
      if(emean-estlf)580,580,550
 550  if(icond.eq.1) goto 700
      icond=1
      iflgrs=0
      goto 100
 580  if(icond-1) 700,595,595
 595  if(irept.eq.1) goto 700
      iflgrs=1
      irept=1
      goto 100
 700  continue
      rh(j)=emean/estair
c     write(6,*)estemp,alam,znum,den,templf(i,j),r,s

      evap(i,j)=1825.*hh*((estair-emean) +s*delt(i,j))
      tran(i,j)=(1.-frwet(j))*1825./r1*(estair-emean+s*delt(i,j))
      gevap(i,j)=evap(i,j)*df(j-1)*frarea(i,j)
      heat(i,j)=2400./rhleaf(j)*delt(i,j)
      gheat(i,j)=heat(i,j)*df(j-1)*frarea(i,j)
      hwater(i,j)=pint1(j)*4187.6*(templf(i,j)-twater)/(dt*df(j-1))
      ghwatr(i,j)=hwater(i,j)*df(j-1)*frarea(i,j)
c
      if(lprin) then
      if(i.eq.100.and.j.eq.2) write(6,'(/,
     &"i,j,znum,den,delt(i,j),templf(i,j),dstrad(3,i,j),dstnet(i,j)"
     & ,"hh,estair,rslst,rhleaf(j),r1,rsleaf(i,j)")')
      if(i.eq.100) 
     &write(6,'(2i3,12f12.6)')
     & i,j,znum,den,delt(i,j),templf(i,j),dstrad(3,i,j),dstnet(i,j)
     & ,hh,estair,rslst,rhleaf(j),r1,rsleaf(i,j)
      endif
c ----------------------------------------------------------------

      dstnet(i,j)=dstnet(i,j)+2.*dstrad(3,i,j)
      dstrad(3,i,j)=emis*sigma*(templf(i,j)+273.)**4
      dstnet(i,j)=dstnet(i,j)-2.*dstrad(3,i,j)
c     write(6,*)temp,delt(i,j),r,s,evap(i,j),heat(i,j),
c    & frarea(i,j),df(j-1)
c stms to check leaf energy bal, should be good to .01wm-2.
      bal=dstnet(i,j)*df(j-1)*frarea(i,j)-gevap(i,j)-gheat(i,j)
     &  -ghwatr(i,j)
      bal2=dstnet(i,j)-evap(i,j)-heat(i,j)-hwater(i,j)
      sumbal=sumbal+bal
c     if((iday.eq.3).and.(ihr.eq.9))write(15,999)iday,ihr,i,j,bal,bal2
c    &   ,ghwatr(i,j),hwater(i,j)
 999  format(4i3,4f8.4)
 1000 continue
c     if((iday.eq.3).and.(ihr.eq.9))write(15,1001)ihr,j,sumbal
 1001 format(' leaf ',2i3,f7.2)
 1100 continue

 
      goto 7777
      write(6,*) ' '
      write(6,*) ' j  delt                                         
     &                                                       d_mean'
      do j=jtot,2,-1
      dsum1=0.0
      do i=1,itotp1
      dsum1=dsum1+delt(i,j)*frarea(i,j)
      enddo
      write(6,'(i3,10f10.4,3x,f10.4)') j,(delt(i,j),i=1,itotp1),dsum1
      enddo


      write(6,*) ' '
      write(6,*) ' j  gevap                 '
      do j=jtot,2,-1
      write(6,'(i3,10f11.6)') j,(evap(i,j),i=1,itotp1)
      enddo
 
      write(6,*) ' '
      write(6,*) ' j  gheat                 '
      do j=jtot,2,-1
      write(6,'(i3,10f11.6)') j,(gheat(i,j),i=1,itotp1)
      enddo
 7777 continue
 
c     if(lprin) then
c     write(6,*) ' '
c     write(6,*) ' j  gevap                 '
c     do j=jtot,2,-1
c     write(6,'(i3,10f11.6)') j,(gevap(i,j),i=1,itotp1)
c     write(6,'(i3,10f11.6)') j,(gheat(i,j),i=1,itotp1)
c     write(6,'(i3,10f11.6)') j,(ghwatr(i,j),i=1,itotp1)
c     write(6,'(i3,10f11.6)') 
c    & j,(dstnet(i,j)*df(j-1)*frarea(i,j),i=1,itotp1)
c     enddo
c     endif
c

      do 2000 j=2,jtot
      sum=0.
      do 1500 i=1,itotp1
      sum=sum+(evap(i,j)-tran(i,j))*frarea(i,j)
 1500 continue
      evint(j)=sum*df(j-1)
 2000 continue
c     if(ihr.eq.21)write(26,405)ihr,isate,iflgrs,irept,icond,eair(jtot),
c    1estlf,tair(jtot)
 405  format(1x,5i3,2(1x,e10.4))
c     if(ihr.eq.19)write(6,*)icond,isate,iflgrs

      return
      end
 

      subroutine stress
      implicit double precision (a-h,o-z)
      parameter (nlev=40)    ! number of levels  
      common/leaf1/delt(10,99),psilf,tran(10,99)
      common/leaf2/evap(10,99),gevap(10,99),heat(10,99),gheat(10,99)
     &,alam
      common/leaf3/hwater(10,99),ghwatr(10,99)
      common/cpy1/etotwt,htot,rplnt,evapg(99),heatg(99),eave(99)
     &,have(99),waterg(99)
      common/cpy2/hsoil,hcpys,evtot,etotw(99),contot(99),scond(10,99)
     1,ecpys,cphstr,cpestr,wcpys,evsmic,ihrwet(99)
      common/misc2/fr(99),ct(99),totlai,df(99)
     &,clai(99),distls(10),itot,itotp1,jtot

c  calc leaf water pot from total evap,soil potent and plant res a
      etotwt=0.
      htot=0.
      tranw=0.
      rplnt=30.
      do 600 j=2,jtot
      evapg(j)=0.
      heatg(j)=0.
      waterg(j)=0.
      etotw(j)=0.
      do 500 i=1,itotp1
c  calc tot flux den per unit of leaf area
      etotwt=etotwt+gevap(i,j)
      htot=htot+gheat(i,j)
      heatg(j)=heatg(j)+gheat(i,j)
      waterg(j)=waterg(j)+ghwatr(i,j)
      evapg(j)=evapg(j)+gevap(i,j)
      etotw(j)=etotw(j)+gevap(i,j)/(alam*4.18e-03)
 500  continue
 600  if(contot(j).ge.0.)tranw=tranw+etotw(j)
      evtot=etotwt
      etotwt=etotwt/(alam*4.18e-3)
c     psilf=psisol(ihr)-tranw/rplnt
      psilf=-.1 ! >>>>>>>>>>>>>>>>>>>>>>>>>>>>
c     write(6,*)etotwt,psilf,htot,a
      return
      end
C


      subroutine rootex
c  subroutine to calculate root extraction from the soil
      implicit double precision (a-h,o-z)
      parameter (nlev=40,nsoil=15)    ! number of levels  
      common/misc2/fr(99),ct(99),totlai,df(99)
     &,clai(99),distls(10),itot,itotp1,jtot
      common/misc4/z(99),zmid(99),jzcpy,jzcpy1,jzsfc,jzsfm1,jzbot,jzcrit
     &,jzbm1
      common/leaf1/delt(10,99),psilf,tran(10,99)
      common/leaf2/evap(10,99),gevap(10,99),heat(10,99),gheat(10,99)
     1,alam
      common/root1/froot(99),resrot(99),rootsm,psixy,psitop,rroot
     1,rootup(99),cpytr,psisum,aroot
      common /rad2/dstrad(3,10,99),dstnet(10,99),frarea(10,99)
     &,templf(10,99),tsoil
      common/soil1/zs(nsoil),sl,dels
      common/feld/ eta(nsoil),psi(nsoil),psit(nsoil),
     &temp(nsoil),xk(nsoil),psieta(nsoil),
     &psitet(nsoil),xlam(nsoil),axa(nsoil),bxb(nsoil),
     &cxc(nsoil),dxd(nsoil),d1t(nsoil),
     &d2t(nsoil),d1eta(nsoil),d2eta(nsoil),
     &xl11(nsoil),xl22(nsoil),rho0(nsoil),
     &rho1(nsoil),rho22(nsoil),xl210(nsoil),
     &p21(nsoil),p21t(nsoil),h(nsoil),datm(nsoil)
      common/soil4/pe,bx,bd,aks,an,ws,asoil,bsoil,csoil,dsoil,esoil
      common/water1/tprecp,wcond(99),wstor(99),iprecp
c
      cpytr=0.
      do 10 j=2,nsoil
      psi(j)=pe*(eta(j)/ws)**(-bx) ! should be replaced by psi from soil model
      if(psi(j).ge.pe) psi(j)=pe
      do 10 i=1,itotp1
      cpytr=cpytr+tran(i,j)*frarea(i,j)
 10   continue
c  convert w m-2 to kg m-2 s-1
      cpytr=cpytr*df(j-1)/(alam*4.18e3)
      psisum=0.
 300  do 200 jz=2,nsoil          
      if(psi(jz).ge.-1500) psisum=psisum+psi(jz)/resrot(jz)
c     write(19,*)ihr,jz,psisum,resrot(jz),rootsm,froot(jz),psi(jz)
 200  continue
 
c  rootsm is sum of reciprocals of root resis from main prog
c      if(cpytr.ge.0)psixy=(-cpytr+psisum)/rootsm
c      if(cpytr.lt.0.)psixy=psisum/rootsm
c above 2 stm were commented and following 3 added. chen, 02/19/90.
        psisum=psisum/rootsm
        if(cpytr.ge.0) psixy=-cpytr/rootsm+psisum
        if(cpytr.lt.0.) psixy=psisum
c  assume .6 of plant resis is in root so rleaf=2*rroot/3
      psitop=psixy-cpytr*rroot*0.6667
      if(cpytr.lt.0.) psitop=psixy
      do 400 jz=2,nsoil            
      rootup(jz)=(psi(jz)-psixy)/resrot(jz)
      if(psi(jz).lt.-1500.) rootup(jz)=0.
 400  continue
      rootup(1)=0.
      rootup(nsoil)=rootup(nsoil-1)
      return
      end

