       Module parameters 
!...Current and previous month leaf area index
      REAL :: averad
      REAL :: LAIc, LAIp
      REAL :: timloc,deltim
      INTEGER :: month,jday,iyear,icumdy
!...number of days in each month
      INTEGER, PARAMETER :: DaysInMonth(12) = (/   
     &   31,28,31,30,31,30,31,31,30,31,30,31 /)
      REAL, PARAMETER :: D2RAD = 3.1415926535/180.0
      INTEGER, PARAMETER :: n_mgn_spc  = 20
      INTEGER, PARAMETER ::     
     &  imgn_isop  =  1    ! isoprene
     & ,imgn_mbo   =  2    ! MBO (only (2-methyl-3-ene-2-ol)-methylbutenol) 
     & ,imgn_myrc  =  3    ! myrcene
     & ,imgn_sabi  =  4    ! sabinene
     & ,imgn_limo  =  5    ! limonene
     & ,imgn_3car  =  6    ! 3 carene
     & ,imgn_ocim  =  7    ! trans-beta-ocimene
     & ,imgn_bpin  =  8    ! beta-pinene
     & ,imgn_apin  =  9    ! alpha-pinene
     & ,imgn_afarn = 10    ! alpha-farnescene
     & ,imgn_bcar  = 11    ! beta-caryophyllene
     & ,imgn_meoh  = 12    ! methanol
     & ,imgn_acto  = 13    ! acetone
     & ,imgn_acta  = 14    ! acetaldehyde and ethanol
     & ,imgn_form  = 15    ! formic acid, formaldehyde, acetic acid
     & ,imgn_ch4   = 16    ! methane
     & ,imgn_no    = 17    ! nitric oxide (and NO2 and NH3 )
     & ,imgn_omtp  = 18    ! other monoterpenes
     & ,imgn_osqt  = 19    ! other sesquiterpenes
     & ,imgn_co    = 20     ! CO and other VOC                          
       REAL , DIMENSION(n_mgn_spc) :: tdf_prm

      DATA  tdf_prm ( imgn_isop  )  / 0.09  / ! isoprene  (but not used for isoprene)
      DATA  tdf_prm ( imgn_mbo   )  / 0.09  / ! MBO (only (2-methyl-3-ene-2-ol)-methylbutenol)
      DATA  tdf_prm ( imgn_myrc  )  / 0.10  / ! myrcene                                
      DATA  tdf_prm ( imgn_sabi  )  / 0.10  / ! sabinene                               
      DATA  tdf_prm ( imgn_limo  )  / 0.10  / ! limonene                               
      DATA  tdf_prm ( imgn_3car  )  / 0.10  / ! 3 carene                               
      DATA  tdf_prm ( imgn_ocim  )  / 0.10  / ! trans-beta-ocimene                     
      DATA  tdf_prm ( imgn_bpin  )  / 0.10  / ! beta-pinene                            
      DATA  tdf_prm ( imgn_apin  )  / 0.10  / ! alpha-pinene                           
      DATA  tdf_prm ( imgn_afarn )  / 0.17  / ! alpha-farnescene                       
      DATA  tdf_prm ( imgn_bcar  )  / 0.17  / ! beta-caryophyllene                     
      DATA  tdf_prm ( imgn_meoh  )  / 0.08  / ! methanol                               
      DATA  tdf_prm ( imgn_acto  )  / 0.11  / ! acetone                                
      DATA  tdf_prm ( imgn_acta  )  / 0.13  / ! acetaldehyde and ethanol               
      DATA  tdf_prm ( imgn_form  )  / 0.09  / ! formic acid, formaldehyde, acetic acid
      DATA  tdf_prm ( imgn_ch4   )  / 0.05  / ! methane                                
      DATA  tdf_prm ( imgn_no    )  / 0.11  / ! nitric oxide (and NO2 and NH3)                          
      DATA  tdf_prm ( imgn_omtp  )  / 0.10  / ! other monoterpenes                     
      DATA  tdf_prm ( imgn_osqt  )  / 0.17  / ! other sesquiterpenes                   
      DATA  tdf_prm ( imgn_co    )  / 0.09  / ! co and other voc                     
      INTEGER, PARAMETER ::        n_cat=5
      REAL, DIMENSION(n_cat) ::    anew, agro, amat, aold
  
      DATA  anew(1),agro(1),amat(1),aold(1) /1.0  , 1.0 , 1.0   , 1.0 /
      DATA  anew(2),agro(2),amat(2),aold(2) /2.0  , 1.8 , 0.95  , 1.0 /
      DATA  anew(3),agro(3),amat(3),aold(3) /0.4  , 0.6 , 1.075 , 1.0 /
      DATA  anew(4),agro(4),amat(4),aold(4) /3.0  , 2.6 , 0.85  , 1.0 /
      DATA  anew(5),agro(5),amat(5),aold(5) /0.05 , 0.6 , 1.125 , 1.0 /
      REAL  :: ldf
      REAL , DIMENSION(n_mgn_spc) :: ldf_fct

      DATA  ldf_fct ( imgn_isop  )  / 0.9999 /  ! isoprene                               
      DATA  ldf_fct ( imgn_mbo   )  / 0.9999 /  ! MBO (only (2-methyl-3-ene-2-ol)-methylbutenol)
      DATA  ldf_fct ( imgn_myrc  )  / 0.05   /  ! myrcene                                
      DATA  ldf_fct ( imgn_sabi  )  / 0.10   /  ! sabinene                               
      DATA  ldf_fct ( imgn_limo  )  / 0.05   /  ! limonene                               
      DATA  ldf_fct ( imgn_3car  )  / 0.05   /  ! 3 carene                               
      DATA  ldf_fct ( imgn_ocim  )  / 0.80   /  ! trans-beta-ocimene                     
      DATA  ldf_fct ( imgn_bpin  )  / 0.10   /  ! beta-pinene                            
      DATA  ldf_fct ( imgn_apin  )  / 0.10   /  ! alpha-pinene                           
      DATA  ldf_fct ( imgn_afarn )  / 0.50   /  ! alpha-farnescene                       
      DATA  ldf_fct ( imgn_bcar  )  / 0.50   /  ! beta-caryophyllene                     
      DATA  ldf_fct ( imgn_meoh  )  / 0.75   /  ! methanol                         
      DATA  ldf_fct ( imgn_acto  )  / 0.25   /  ! acetone                                
      DATA  ldf_fct ( imgn_acta  )  / 0.50   /  ! acetaldehyde and ethanol ??          
      DATA  ldf_fct ( imgn_form  )  / 0.50   /  ! formic acid, formaldehyde, acetic acid ??
      DATA  ldf_fct ( imgn_ch4   )  / 0.75   /  ! methane                                
      DATA  ldf_fct ( imgn_no    )  / 0.00   /  ! nitric oxide (and NO2 and NH3 )                          
      DATA  ldf_fct ( imgn_omtp  )  / 0.10   /  ! other monoterpenes                     
      DATA  ldf_fct ( imgn_osqt  )  / 0.50   /  ! other sesquiterpenes                   
      DATA  ldf_fct ( imgn_co    )  / 0.50   /  ! CO and other VOC                    
      INTEGER :: previous_month
      REAL :: Tsa, tsa24 
      REAL :: par, par24 
      REAL :: xlat, xlong 
      REAL :: gam_TMP, gam_AGE, gam_LHT, gam_PHO 
      END module parameters

      subroutine sourcesMEGAN(vcp,lprin,jday, timloc) 
c Old BVOC emission routine, follwing Guenther et al. 'plant type' equal 1 or 2 in input file
      use parameters
      implicit double precision (a-h,o-z)
      REAL, DIMENSION(n_mgn_spc) :: adjust_factor
      real, intent(in)           :: timloc
      parameter (nlev=40)    ! number of levels  
      parameter (nspec=77, nrect=237)
      parameter(maxrect=500)

      logical lprin
      common/height/z(nlev),zf(nlev),dz(nlev),dzf(nlev)
      common/atmo1/ t(nlev),theta(nlev),p(nlev),rhoair(nlev)
     & ,relh(nlev)
      common /cpy/ hcpy,htr,tlai,levcpy,levhtr,zrough,sizelf
      common /rad2/dstrad(3,10,99),dstnet(10,99),frarea(10,99)
     &,templf(10,99),tsoil
      real:: dstrad_temp
      common/rad4/d(3,99),u(3,99),bmflx(3,99),rnet(99),rndiv(99),
     &tsfc,rnlam(3,99)
      common/misc2/fr(99),ct(99),totlai,df(99)
     &,clai(99),distls(10),itot,itotp1,jtot
      common/efact/ efiso,efterp,efovoc,reflai,
     & splitterp(3),splitovoc(9)

      common/etc/fiso,fapi,flim,fmacr,sumsiso,sumsapi,sumslim,fapi2
     &,fiso2,flim2,fmacr2
       dimension vcp(nlev,nspec)
       dimension gammat(10,99),gammatl(99) ! ,gammata(20),gammair(20)
       real,dimension(10,99)::  gammat_MEGAN
       real,dimension(99):: gammatl_MEGAN
       real,dimension(10,99)::  gammal_MEGAN
       real,dimension(99):: gammall_MEGAN
       dimension gammal(10,99),gammall(99)
       dimension gammt(10,99),gammatt(99)
       dimension shilfi(99),shilft(99),shilfo(99),
     & sourcli(99),sourclt(99),sourclo(99)

      common/quellen/source(nlev,nspec)
      common/cpysrc/ evaps(99),heats(99)

      common/spezies/
     &    LACO3, LADDC, LADDT, LADDX, LALD , LAPI , LAPIP, LCH4,
     &    LCO  , LCO2 , LCSL , LCSLP, LDCB , LDIEN, LETE , LETEP,
     &    LETH , LETHP, LGLY , LH2  , LH2O , LH2O2, LHC3 , LHC3P,
     &    LHC5 , LHC5P, LHC8 , LHC8P, LHCHO, LHKET, LHNO3, LHNO4,
     &    LHO  , LHO2 , LHONO, LISO , LISOP, LKET , LKETP, LLIM,
     &    LLIMP, LMACR, LMGLY, LMO2 , LN2  , LN2O5, LNO  , LNO2,
     &    LNO3 , LO1D , LO2  , LO3  , LO3P , LOLI , LOLIP, LOLND,
     &    LOLNN, LOLT , LOLTP, LONIT, LOP1 , LOP2 , LORA1, LORA2,
     &    LPAA , LPAN , LPHO , LSO2 , LSULF, LTCO3, LTOL , LTOLP,
     &    LTPAN, LUDD , LXO2 , LXYL , LXYLP

      
       do k=1,nlev
       do jspec=1,nspec
       source(k,jspec)=0.
       enddo
       enddo

c  water vapor from lfebal 
      do k=2,nlev-1
      alam=(597.-0.57*(t(k)-273.15))*4.18e03
       source(k,lh2o)=0.5*(evaps(k)+evaps(k-1))/alam/dz(k) 
       source(k,lh2o)=source(k,lh2o)/rhoair(k)/0.622
c     if(k.le.levcpy) 
c    &write(06,'("sh2o",i3,e12.4)') k,source(k,lh2o)
      enddo


c     source strength in  1/sec

c ISO
        fluxa=0.
      do j=2,jtot      ! Bezug auf die Schichten            
       gammatl(j)=0.
       gammatl_MEGAN(j)=0.
       gammall(j)=0.
       gammall_MEGAN(j)=0.
       gammatt(j)=0.
       shilfi(j)=0.
       shilft(j)=0.
       shilfo(j)=0.
       tsa = 0 
       do i=1,itotp1
        tsa = tsa + templf(i,j)
       enddo
       tsa = tsa/itotp1+273.15
c      if(gammall(j).gt.1000.) then
c      write(06,'("gammt",i3,10e12.4)') j,(gammt(i,j),i=1,itotp1)
c      write(06,'("frarea",i3,10e12.4)') j,(frarea(i,j),i=1,itotp1)
c      write(06,'(" g*f  ",i3,12e12.4)') j,gammatt(j),
c    & (frarea(i,j)*gammt(i,j),i=1,itotp1)
c      endif

c  efiso: Source strength per m**3 referring to  1m**2 leaf/m**2 ground           
c       if(j.lt.jtot-4) then
c       efisoh=20*efiso
c       else
c       efisoh=.5*efiso
c       endif
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!MEGAN!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
          ! ------------------------------------------------------------
          !
          !  MEGAN v2.04 Box Model
          !
          !  Reference: 
          !
          !    Estimates of global terrestial isoprene emissions using MEGAN
          !    (Model of Emissions of Gases and Aerosols from Nature )
          !    A. Guenther, T. Karl, P. Harley, C. Wiedinmyer, 
          !    P.I. Palmer, and C. Geron
          !    Atmospheric Chemistry and Physics, 6, 3181-3210, 2006      
          !
          !    MEGAN v2.0 Documentation
          !
          !
          !  The following code is based on Tan's megan.F dated 11/21/2006
          !
          !   Scientific algorithm
          !
          !           Emission = [epsilon][gamma][rho]
          !
          !         where [epsilon] = emission factor (usually um m-2 hr or mole km-2 hr-1)
          !               [gamma]   = emission activity factor (dimensionless)
          !               [rho]     = production and loss within plant canopies
          !                         (dimensionless)
          !
          !            [gamma]  = [gamma_CE][gamma_age][gamma_SM]
          !
          !         where [gamma_CE]  = canopy correction factor
          !               [gamma_age] = leaf age correction factor
          !               [gamma_SM]  = soil moisture correction factor
          !
          !            [gamma_CE] = [gamma_LAI][gamma_T]((1-LDF) + LDF*[gamma_P] )
          !                      
          !         where [gamma_LAI] = leaf area index factor
          !               [gamma_P]   = PPFD emission activity factor
          !               [gamma_T]   = temperature response factor
          !               LDF         = 
          !
          !           Emission = [epsilon][gamma_LAI][gamma_T][gamma_age]
          !                      x ((1-LDF) + LDF*[gamma_P] )[rho]
          !
          !     or
          ! 
          !           Emission = adjust_factor [epsilon]
          !
          !         where
          !
          !           adjust_fact = [gamma_LAI][gamma_T][gamma_age]((1-LDF) + LDF*[gamma_P] )[rho]
          ! Calculate the dimensionless emission adjustment factor. 
          ! MEGAN v2.04 has n_spca_spc = 138 species.  These species are 
          ! lumped into n_mgn_spc=20 classes.  The emission adjustment
          ! factors are different for the 20 classes of species.
          !
          ! NOTE: This version of the code contains the corrected equation for 
          ! gamma P (based on a revised version of equation 11b from Guenther et al., 2006)
          ! CW (08/16/2007)
          !
          ! NOTE: This version of the code contains the updated emission factors (static)
          ! and beta values based on Alex's V2.1 notes sent out on August 13, 2007
          ! CW (08/16/2007)
          ! 
          ! NOTE: This version of the code applies the same gamma T equation to the 
          ! emissions of all compounds other than isoprene. This occurs regardless 
          ! of whether the emissions are light dependent or not. This is NOT the same 
          ! as what Alex has in his code. In his code, the light-dependent emissions
          ! are also given the isoprene gamma T. Because all emissions (other than isoprene
          ! are assigned the same gamma T, this could lead to overestimates of emissions
          ! at high temperatures (>40C). Light-dependent emisisons (e.g., SQTs) should
          ! fall off at high temperatures. (CW, 08/16/2007)

          !...Calculate adjustment factor components that are species-independent

          !......assume 4.766 (umol m-2 s-1) per (W m-2)
          !......assume 1/2 of swd is in 400-700 nm band
!          par = 4.766 * 0.5 * swd
      IF (current_month > 1) THEN
       previous_month = current_month -1
      ELSE
       previous_month = 12
      END IF

          par = 4.766 * 0.5 * averad 

          !......Check max/min bounds of PAR
          IF ( par .LT. 0.00 .OR. par .GT. 2600.0 ) THEN
             Print*,"par out of range  par =",par
          END IF

          !......For the 24-avg PAR, 
          !......assume 4.766 (umol m-2 s-1) per (W m-2)
          !......assume 1/2 of swd is in 400-700 band
          swd24=520  ! modify if necessary xhu
          par24 = swd24 * 4.766 * 0.5

          !......Get the leaf area index factor gam_LHT

          CALL GAMMA_LAI( LAIc, gam_LHT)

          !......Get the light emission activity factor gam_PHO
          CALL GAMMA_P( jday, timloc, xlat, xlong, par, par24, gam_PHO )

          !......Get the soil moisture factor gam_SMT
          !......for now, set = 1.0
          gam_SMT = 1.0

          !...Calculate the overall emissions adjustment factors, for
          !...each of the n_mgn_spc=20 classes of compounds
          tsa24 = 273.15+24 
          DO i_class = 1, n_mgn_spc

             ! Get the temperature response factor gam_TMP
             !  One algorithm for isoprene, and one for non-isoprene

             IF ( i_class == imgn_isop ) THEN
                CALL GAMMA_TISOP( tsa, tsa24, gam_TMP )
             ELSE
                CALL GAMMA_TNISP( i_class , tsa, gam_TMP  )
             END IF

             ! Get the leaf age correction factor gam_AGE

             !...Time step (days) between LAIc and LAIp:
             !...Since monthly mean LAI is used,
             !...use # of days in the previous month
             tstlen = REAL(DaysInMonth(previous_month),KIND(1.0))

             CALL GAMMA_A( i_class , LAIp, LAIc, TSTLEN, tsa24, gam_AGE)

             ! rho - normalized ratio accounting for production and
             ! oss within plant canopies; rho_fct is defined in 
             ! module_data_megan2.F; currently rho_fct = 1.0 for all 
             ! species (dimensionless)
             rho = 1 !rho_fct(i_class)

             ! Fraction of emission to apply light-dependence factor
             ! ldf_fct is defined in module_data_megan2.F
             ! (dimensionless)
             ldf = ldf_fct(i_class)

             ! The overall emissions adjustment factor
             ! (dimensionless)

             adjust_factor(i_class) = gam_TMP * gam_AGE * gam_LHT 
     &            * gam_SMT * rho * 
     &            ( (1.0-LDF) + gam_PHO*LDF )

          END DO !i_class = 1, n_mgn_spc (loop over classes of MEGAN species )

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!MEGAN END !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


       do i=1,itotp1
c Isoprene emission, factor C_T (temperature)
       gammat(i,j)=gammct(templf(i,j))  !templf refers to layers Guenther,1995,JGR
c Isoprene emission, factor C_L (light)
       gammal(i,j)=gammcl(dstrad(1,i,j))
c Terpene and OVOC correction factor (temperature)
       gammt(i,j)=gammtf(templf(i,j))

!use MEGAN
       tsa = templf(i,j)+273.15
       call GAMMA_TISOP( tsa, tsa24, gammat_MEGAN(i,j) )
        dstrad_temp = dstrad(1,i,j)
       call gammcl_MEGAN(dstrad_temp, gammal_MEGAN(i,j)) 

       gammatl(j)=gammatl(j)+gammat(i,j)*frarea(i,j)
       gammatl_MEGAN(j)=gammatl_MEGAN(j)+gammat_MEGAN(i,j)*frarea(i,j)
       gammall(j)=gammall(j)+gammal(i,j)*frarea(i,j)
       gammall_MEGAN(j)=gammall_MEGAN(j)+gammal_MEGAN(i,j)*frarea(i,j)
       gammatt(j)=gammatt(j)+gammt(i,j)*frarea(i,j)
       enddo
       shilfi(j)=efiso *df(j-1)
       if (j.ge.6) then 
          shilfi(j)=efiso *df(j-1)/10000000.   ! Loblolly Pine doesn't emit isoprene
!x          print*, "Loblolly Pine doesn't emit isoprene"
       end if 
!       shilfi(j)=shilfi(j)*gammatl(j)*gammall(j)
       ldf = ldf_fct(imgn_isop)
       shilfi(j)=shilfi(j)*gammatl_MEGAN(j)*
     $       ((1.0-LDF)+gammall_MEGAN(j)*LDF)   !adjust_factor(imgn_isop)
                              ! df refers to the layers, however the index starts at 1
                              ! Emission per layer
!x       write(*,'(A,I3,A,3f10.3,A,2f10.3)'),"emission factor, layer",j," 
!     $ gamt, gaml,gamt_mono", 
!     $                       gammatl(j),gammall(j),gammatt(j)," MEGAN", 
!     $                            gammatl_MEGAN(j),gammall_MEGAN(j) 
c a-pinene
       shilft(j)=efterp*df(j-1)        
       if (j.le.6) then
         shilft(j)=efterp*df(j-1)/15.0 !Sweet gum has lower rate       
       end if 
       fluxa=fluxa+shilft(j)
         ldf = ldf_fct(imgn_apin)
       shilft(j)=shilft(j)*gammatt(j)*
     $   ((1.0-LDF)+gammall_MEGAN(j)*LDF)               

c OVOC
       shilfo(j)=efovoc*df(j-1)       
       shilfo(j)=shilfo(j)*gammatt(j)*
     $   ((1.0-LDF)+gammall_MEGAN(j)*LDF)                           

       if(lprin) then
c      if(gammall(j).gt.0.) then
      write(06,'("shilf",i3,8e12.4)') j,shilfi(j),shilft(j),
     & gammatl(j),gammall(j),gammatt(j),df(j-1)
c      endif
       endif
      enddo  ! j=2,jtot  

      fluxa=fluxa/12. ! Mittelwert

      do k=1,nlev
      sourcli(k)=0.
      sourclt(k)=0.
      sourclo(k)=0.
      enddo

      do j=2,jtot
      sourcli(levhtr-2+j)=shilfi(j)
      sourclt(levhtr-2+j)=shilft(j)
      sourclo(levhtr-2+j)=shilfo(j)
      enddo
c

c  Source strength in m**3            
c   potential isoprene source strength 
      sumsiso=0.
      sumsapi=0.
      sumslim=0.
      do k=2,nlev   
c        source(k ,liso)=0.001e-9   ! 3.6 ppb/h 
c      source(k,liso)=0.5*(sourcl(k)+sourcl(k-1))/(z(levcpy)-z(levhtr))
c  ls=36 !ISO
       source(k,liso)=0.5*(sourcli(k)+sourcli(k-1))

c Split of terpenes accordung to W.Seidl (priv. comm.)

c API represents alpha-Pinene, beta-Pinen, 3Carene and Sabinene
c LIM represents Limonen, alpha-Terpinene, beta-Terpinene, 
c                 alpha-Phellandrene and beta-Phellandrene
c P-Cymene is represented by XYL
c M. Kuhn, priv. comm., Feb. 1998

       sterp=0.5*(sourclt(k)+sourclt(k-1))
c     ls=6    !API
        source(k,lapi)=splitterp(1)*sterp
      sumsapi=sumsapi+source(k,lapi)*0.5*(dz(k)+dz(k-1))  


c     ls=36   !ISO
        source(k,liso)=source(k,liso)+splitterp(2)*sterp
      sumsiso=sumsiso+source(k,liso)*0.5*(dz(k)+dz(k-1))  
c     ls=40   !LIM
        source(k,llim)=splitterp(3)*sterp
      sumslim=sumslim+source(k,llim)*0.5*(dz(k)+dz(k-1))  

c Split of OVOC    
       sovoc=0.5*(sourclo(k)+sourclo(k-1))
c     ls=23   !HC3
        source(k,lhc3)=splitovoc(1)*sovoc
c     ls=25   !HC5
        source(k,lhc5)=splitovoc(2)*sovoc
c     ls=58   !OLT
        source(k,lolt)=splitovoc(3)*sovoc
c     ls=54   !OLI
        source(k,loli)=splitovoc(4)*sovoc
c     ls=29   !HCHO
        source(k,lhcho)=splitovoc(5)*sovoc
c     ls=5    !ALD
        source(k,lald)=splitovoc(6)*sovoc
c     ls=38   !KET
        source(k,lket)=splitovoc(7)*sovoc
c     ls=63   !ORA1
        source(k,lora1)=splitovoc(8)*sovoc
c     ls=64   !ORA2
        source(k,lora2)=splitovoc(9)*sovoc


      if(lprin.and.k.le.25) 
     &write(06,'("siso,sapi",i3,8e12.4)') k,source(k,liso),
     &   source(k,lapi)
      enddo

      write(06,'("sumapi",8e12.4)') sumsapi*1.e9*5.44,
     &             fluxa*1.e9*5.44*20.
      write(06,'("sumsiso, sumsapi",2e12.4)') 
     &   sumsiso*1.e9*40., sumsapi*1.e9*40.
c
c  NO source at surface   ! ###########  Adapt, if necessary
      ft=exp(0.071*(t(1)-273.15))
      source(1,lno)= 0.0125e-12/dzf(1)*ft  
c     source(1,lno)= 0.125e-12/dzf(1)*ft  


      return
      end

! -----------------------------------------------------------------
!  SUBROUTINE GAMMA_TISOP returns the GAMMA_T value for isoprene
!  Orginally from Tan's gamma_etc.F
! -----------------------------------------------------------------

       SUBROUTINE GAMMA_TISOP( TEMP, D_TEMP, gam_T )
      !
      !  Description :
      !
      !    MEGAN biogenic emissions adjustment factor for temperature
      !    for isoprene
      !
      !  Reference: 
      !
      !    Estimates of global terrestial isoprene emissions using MEGAN
      !    (Model of Emissions of Gases and Aerosols from Nature )
      !    A. Guenther, T. Karl, P. Harley, C. Wiedinmyer, 
      !    P.I. Palmer, and C. Geron
      !    Atmospheric Chemistry and Physics, 6, 3181-3210, 2006      !
      !

      IMPLICIT NONE

      ! hourly surface air temperature (K)
      ! (here use instantaneous temperature
      REAL, INTENT(IN)  :: TEMP
      ! daily-mean surface airtemperature (K)
      ! (here use the previous month's monthly mean)
      REAL, INTENT(IN)  :: D_TEMP
      !temperature adjustment factor
      REAL, INTENT(OUT) :: gam_T

      ! Local parameters
      REAL :: Eopt, Topt, X
      REAL :: AAA, BBB
      REAL, PARAMETER :: CT1 = 80.0
      REAL, PARAMETER :: CT2 = 200.0
      
      ! End header ----------------------------------------------------

      ! Below Eqn (14) of Guenther et al. [2006]
      ! (assuming T_daily = D_TEMP)
      Eopt = 1.75 * EXP(0.08*(D_TEMP-297.0))
! since we have detailed canopy environment model 
! we should probably use Eqn (5) of Guenther et al. [2006]
!      Eopt = 2.034 * EXP(0.05*(D_TEMP-297.0))
        
      ! Eqn (8) of Guenther et al. [2006]
      ! (assuming T_daily = D_TEMP)
      Topt = 313.0 + ( 0.6*(D_TEMP-297.0) )

      ! Eqn (5) of Guenther et al. [2006]
      X = ( (1.0/Topt)-(1.0/TEMP) ) / 0.00831
      AAA = Eopt*CT2*EXP(CT1*X)
      BBB = (  CT2-CT1*( 1.0-EXP(CT2*X) )  )
      gam_T = AAA/BBB

      END SUBROUTINE GAMMA_TISOP

! -----------------------------------------------------------------
! SUBROUITINE GAMMA_TNISP returns the GAMMA_T value for 
! non-isoprene species
! Originally from Tan's gamma_etc.F
!------------------------------------------------------------------

       SUBROUTINE GAMMA_TNISP( SPCNUM, TEMP, gam_T )
       use parameters
      !
      !  Description :
      !
      !    MEGAN biogenic emissions adjustment factor for temperature
      !    for non-isoprene species.
      !
      !  Reference:
      !
      !    MEGAN v2.0 Documentation
      !
      ! Method:
      !
      !    GAMMA_T =  exp[BETA*(T-Ts)]
      !      where BETA   = temperature dependent parameter
      !            Ts     = standard temperature (normally 303K, 30C)
      !

      IMPLICIT NONE

      INTEGER, INTENT(IN) :: SPCNUM               ! Species number
      REAL, INTENT(IN)    :: TEMP
      REAL, INTENT(OUT)   :: gam_T
      REAL, PARAMETER     :: Ts = 303.0
      
      ! End header ----------------------------------------------------

      ! TDF_PRM is defined in module_data_megan2.F
      gam_T = EXP( TDF_PRM(SPCNUM)*(TEMP-Ts) )

      END SUBROUTINE GAMMA_TNISP


! --------------------------------------------------------------------
! SUBROUTINE GAMMA_LAI
! Originally from Tan's gamma_etc.F
! --------------------------------------------------------------------

       SUBROUTINE GAMMA_LAI(LAI, gam_L )
      !  Description :
      !
      !    MEGAN biogenic emissions adjustment factor for leaf area
      !    index
      !
      !  Reference: 
      !
      !    Estimates of global terrestial isoprene emissions using MEGAN
      !    (Model of Emissions of Gases and Aerosols from Nature )
      !    A. Guenther, T. Karl, P. Harley, C. Wiedinmyer, 
      !    P.I. Palmer, and C. Geron
      !    Atmospheric Chemistry and Physics, 6, 3181-3210, 2006      !
      !
      ! Method:
      !                       0.49[LAI]
      !        GAMMA_LAI = ----------------    (dimensionless)
      !                    (1+0.2LAI^2)^0.5
      !

      IMPLICIT NONE
      REAL, INTENT(IN)  ::  LAI 
      REAL, INTENT(OUT) :: gam_L

      ! End header ----------------------------------------------------

      
      ! Eqn (15) of Guenther et al. [2006]
      gam_L = (0.49*LAI) / ( SQRT(1.0+0.2*(LAI**2)) )

      RETURN
      END SUBROUTINE GAMMA_LAI

!-------------------------------------------------------------------
! SUBROUTINE GAMMA_P 
! Originally from Tan's gamma_etc.F
!-------------------------------------------------------------------
       SUBROUTINE GAMMA_P(             
     $    DOY_in, tmidh, LAT, LONG,                      
     $    PPFD, D_PPFD, gam_P        
     $    )
      !
      !  Description :
      !
      !    MEGAN biogenic emissions adjustment factor for
      !    photosynthetic photon flux density (PPFD or PAR)
      !
      !  Reference: 
      !
      !    Estimates of global terrestial isoprene emissions using MEGAN
      !    (Model of Emissions of Gases and Aerosols from Nature )
      !    A. Guenther, T. Karl, P. Harley, C. Wiedinmyer, 
      !    P.I. Palmer, and C. Geron
      !    Atmospheric Chemistry and Physics, 6, 3181-3210, 2006      
      !  
      !  Method:
      !
      !    GAMMA_P = 0.0         sin(a)<=0
      !
      !    GAMMA_P = sin(a)[2.46*0.9*PHI^3*(1+0.0005(Pdaily-400))]
      !                                  0<a<180
      !           where PHI = above canopy PPFD transmission (non-dimension)
      !           Pdaily    = daily average above canopy PPFD (umol/m2s)
      !              a      = solar angle (degree)
      !
      !         Note: AAA = 2.46*BBB*PHI-0.9*PHI^2
      !               BBB = (1+0.0005(Pdaily-400))
      !           GAMMA_P = sin(a)*AAA
      !
      !                       Pac
      !             PHI = -----------
      !                   sin(a)*Ptoa
      !
      !     where Pac  = above canopy PPFD (umol/m2s)
      !                 Ptoa = PPFD at the top of atmosphere (umol/m2s)
      !
      !             Pac =  SRAD * 4.766 mmmol/m2-s * 0.5
      !
      !             Ptoa = 3000 + 99*cos[2*3.14-( DOY-10)/365 )]
      !        where DOY = day of year (julian day)
      !
      ! NOTE: This code has been corrected. The gamma P equation as defined in the
      ! original Guenther et al., 2006 (equation 11b) is incorrect. This has the
      ! corrected algorithm. (CW, 08/16/2007)
      !-----------------------------------------------------------------

      IMPLICIT NONE

      INTEGER, INTENT(IN) :: DOY_in ! julian day at GMT

      ! GMT hour plus minutes (in fractaionl hour) of the middle
      ! of the current time step
      REAL, INTENT(IN)  :: tmidh
      REAL, INTENT(IN)  ::  LAT    ! Latitude [=] degrees
      REAL, INTENT(IN)  ::  LONG   ! Longitude [=] degrees
      REAL, INTENT(IN)  ::  PPFD   ! Photosynthetic Photon Flus Density
      REAL, INTENT(IN)  ::  D_PPFD ! Daily PPFD
      REAL, INTENT(OUT) ::  gam_P  ! GAMMA_P


      !...  Local scalars
      INTEGER :: DOY                 ! local julian day
      REAL :: HOUR                   ! solar hour
      REAL :: AAA, BBB
      REAL :: SIN_solarangle         ! sin(solar angle)
      REAL :: Ptoa, Pac, PHI

      ! End header ----------------------------------------------------

      ! Convert time of the middle of the current time step
      ! from GMT to solar hour (include minutes in decimals)
      DOY = DOY_in
!      HOUR = tmidh + long/15.
      HOUR = tmidh !+ long/15.  already local time
      IF ( HOUR .LT. 0.0 ) THEN
         HOUR = HOUR + 24.0
         DOY  = DOY - 1
      ENDIF

      ! Above canopy photosynthetic photo flux density (PPFD)
      ! ( micromole/m2/s )
      Pac = PPFD
 
      ! Get sin of solar elevation angle
      CALL SOLARANGLE( DOY, HOUR, LAT, SIN_solarangle )

      ! Calculate gamma_p in Eqn (10) of Guenther et al. [2006]
      IF ( SIN_solarangle .LE. 0.0 ) THEN
         ! Eqn (11a) of Guenther et al. [2006]
         gam_P = 0.0
      ELSE
         ! PPFD at top of the atmosphere
         ! Eqn (13) of Guenther et al. [2006]
         ! ( micromole/m2/s )
         Ptoa = 3000.0 + 99.0 * COS( 2.*3.14*(DOY-10.)/365. )
         ! Above canopy PPFD transmission
         ! Eqn (12) of Guenther et al. [2006]
         ! (nondimensional)
         PHI = Pac/(SIN_solarangle * Ptoa)
         ! Eqn (11b) of Guenther et al. [2006]
         ! (Note: typo in the paper; correction made 08/06/2007)
         BBB = 1. + 0.0005*( D_PPFD-400. )
         AAA = 2.46 * BBB * PHI - 0.9 * (PHI**2)
         gam_P = SIN_solarangle * AAA

      ENDIF
      ! Screening the unforced errors
      ! IF solar elevation angle is less than 1 THEN
      ! gamma_p can not be greater than 0.1.
      IF (SIN_solarangle .LE. 0.0175 .AND. gam_P .GT. 0.1) THEN
         gam_P = 0.1
      ENDIF


      END SUBROUTINE GAMMA_P

! ----------------------------------------------------------------
! SUBROUTINE GAMMA_A returns GAMMA_A
! Originally from Tan's gamma_etc.F
!------------------------------------------------------------------
       SUBROUTINE GAMMA_A( i_spc, LAIp, LAIc, TSTLEN, D_TEMP, gam_A )
       use parameters
      !  Description :
      !
      !    MEGAN biogenic emissions adjustment factor for leaf age
      !
      !  Reference: 
      !
      !    Estimates of global terrestial isoprene emissions using MEGAN
      !    (Model of Emissions of Gases and Aerosols from Nature )
      !    A. Guenther, T. Karl, P. Harley, C. Wiedinmyer, 
      !    P.I. Palmer, and C. Geron
      !    Atmospheric Chemistry and Physics, 6, 3181-3210, 2006
      !
      !    MEGAN v2.0 Documentation
      !
      !
      ! Method:
      !
      !     GAMMA_age = Fnew*Anew + Fgro*Agro + Fmat*Amat + Fold*Aold
      !      where Fnew = new foliage fraction
      !            Fgro = growing foliage fraction
      !                 Fmat = mature foliage fraction
      !                 Fold = old foliage fraction
      !                 Anew = relative emission activity for new foliage
      !                 Agro = relative emission activity for growing foliage
      !                 Amat = relative emission activity for mature foliage
      !                 Aold = relative emission activity for old foliage
      !
      !
      !             For foliage fraction
      !             Case 1) LAIc = LAIp
      !             Fnew = 0.0  , Fgro = 0.1  , Fmat = 0.8  , Fold = 0.1
      !
      !             Case 2) LAIp > LAIc
      !             Fnew = 0.0  , Fgro = 0.0
      !             Fmat = 1-Fold
      !             Fold = (LAIp-LAIc)/LAIp
      !
      !             Case 3) LAIp < LAIc
      !             Fnew = 1-(LAIp/LAIc)                       t <= ti
      !                  = (ti/t) * ( 1-(LAIp/LAIc) )          t >  ti
      !
      !             Fmat = LAIp/LAIc                           t <= tm
      !                  = (LAIp/LAIc) +
      !                      ( (t-tm)/t ) * ( 1-(LAIp/LAIc) )  t >  tm
      !
      !             Fgro = 1 - Fnew - Fmat
      !             Fold = 0.0
      !
      !           where
      !             ti = 5 + (0.7*(300-Tt))                   Tt <= 303
      !                = 2.9                                  Tt >  303
      !             tm = 2.3*ti
      !
      !             t  = length of the time step (days)
      !             ti = number of days between budbreak and the induction of
      !                  emission
      !             tm = number of days between budbreak and the initiation of
      !                  peak emissions rates
      !             Tt = average temperature (K) near top of the canopy during
      !                  current time period (daily ave temp for this case)
      !
      !
      !             For relative emission activity
      !             Case 1) Constant
      !             Anew = 1.0  , Agro = 1.0  , Amat = 1.0  , Aold = 1.0
      !
      !             Case 2) Monoterpenes
      !             Anew = 2.0  , Agro = 1.8  , Amat = 0.95 , Aold = 1.0
      !
      !             Case 3) Sesquiterpenes
      !             Anew = 0.4  , Agro = 0.6  , Amat = 1.075, Aold = 1.0
      !
      !             Case 4) Methanol
      !             Anew = 3.0  , Agro = 2.6  , Amat = 0.85 , Aold = 1.0
      !
      !             Case 5) Isoprene
      !             Anew = 0.05 , Agro = 0.6  , Amat = 1.125, Aold = 1.0


      IMPLICIT NONE

      ! SUBROUTINE arguments

      !..."Pointer" for class of species
      INTEGER, INTENT(IN) :: i_spc
      !...average temperature of the previous 24-hours
      REAL, INTENT(IN) :: D_TEMP
      !...leaf area index of the current and previous
      !...month
      REAL, INTENT(IN) :: LAIp, LAIc
      !...time step between LAIc and LAIp (days)
      REAL, INTENT(IN) ::     TSTLEN
      !...emissions adjustment factor accounting for leaf age
      REAL, INTENT(OUT) :: gam_A

      ! Local scalars

      !...leaf age fractions
      REAL :: Fnew, Fgro, Fmat, Fold
      !...relative emission activity index
      INTEGER ::  AINDX 
      !...time step between LAIC and LAIp (days)
      INTEGER :: t 
      !...number of days between budbreak and the induction emission
      REAL     ti
      !...number of days between budbreak  and the initiation of peak
      !...emissions rates
      REAL     tm
      !

      REAL     Tt                   ! average temperature (K)
      ! daily ave temp

      ! End header ----------------------------------------------------

      ! Choose relative emission activity class
      ! See Table 2 of MEGAN v2.0 Documentation
      !

      IF (      (i_spc==imgn_acto) .OR. (i_spc==imgn_acta) 
     &                            .OR. (i_spc==imgn_form)  
     &      .OR. (i_spc==imgn_ch4)  .OR. (i_spc==imgn_no)   
     &                              .OR. (i_spc==imgn_co)     
     &      ) THEN
         AINDX = 1

      ELSE IF ( (i_spc==imgn_myrc) .OR. (i_spc==imgn_sabi) 
     &                             .OR. (i_spc==imgn_limo)   
     &     .OR. (i_spc==imgn_3car) .OR. (i_spc==imgn_ocim) 
     &                             .OR. (i_spc==imgn_bpin)   
     &     .OR. (i_spc==imgn_apin) .OR. ( i_spc==imgn_omtp)    
     &           ) THEN
         AINDX = 2

      ELSE IF ( (i_spc==imgn_afarn) .OR. (i_spc==imgn_bcar) 
     &                              .OR. (i_spc==imgn_osqt)  
     &      ) THEN
         AINDX = 3

      ELSE IF (i_spc==imgn_meoh) THEN
         aindx = 4

      ELSE IF ( (i_spc==imgn_isop) .OR. (i_spc==imgn_mbo) ) THEN
         aindx = 5
      ELSE
         print*,"Invalid i_spc in SUBROUTINE GAMMA_A; i_spc = ",  i_spc
      END IF



      ! Time step between LAIp and LAIc (days)
      t = TSTLEN
! Tt is the average ambient air temperature (K) of the preceeding time
! interval.  Here, use the monthly-mean surface air temperature
      Tt   = D_TEMP

      ! Calculate foliage fraction
      ! (section 3.2.2 of Guenther et al. [2006])
      IF (LAIp .EQ. LAIc) THEN
         Fnew = 0.0
         Fgro = 0.1
         Fmat = 0.8
         Fold = 0.1
      ELSEIF (LAIp .GT. LAIc) THEN
         Fnew = 0.0
         Fgro = 0.0
         Fold = ( LAIp-LAIc ) / LAIp
         Fmat = 1.0-Fold
      ELSE ! LAIp < LAIc
        ! Calculate ti, which is the number of days between budbreak and
         ! the induction of isoprene emission.
         IF (Tt .LE. 303.0) THEN
            ! Eqn (18a) of Guenther et al. [2006]
            ti = 5.0 + 0.7*(300.0-Tt)
         ELSE
            ! Eqn (18b) of Guenther et al. [2006]
            ti = 2.9
         ENDIF
         ! tm is the number of days between budbreak and the initiation
         ! of peak isoprene emissions rates.
         ! Eqn (19) of Guenther et al. [2006]
         tm = 2.3*ti

         ! Calculate Fnew and Fmat, then Fgro and Fold
         !  Fnew
         IF (t .LE. ti) THEN
            ! Eqn (17a) of Guenther et al. [2006]
            Fnew = 1.0 - (LAIp/LAIc)
         ELSE
            ! Eqn (17b) of Guenther et al. [2006]
            Fnew = (ti/t) * ( 1-(LAIp/LAIc) )
         ENDIF

         ! Fmat
         IF (t .LE. tm) THEN
            ! Eqn (17c) of Guenther et al. [2006]
            Fmat = LAIp/LAIc
         ELSE
            ! Eqn (17d) of Guenther et al. [2006]
            Fmat = (LAIp/LAIc) + ( (t-tm)/t ) * ( 1-(LAIp/LAIc) )
         ENDIF

         Fgro = 1.0 - Fnew - Fmat
         Fold = 0.0

      ENDIF

      !Calculate GAMMA_A
      ! Anew, Agro, Amat, Aold are defined in module_data_megan2.F
      gam_A = Fnew*Anew(AINDX) + Fgro*Agro(AINDX)    
     $      + Fmat*Amat(AINDX) + Fold*Aold(AINDX)


      END SUBROUTINE GAMMA_A

! ----------------------------------------------------------------
! SUBROUTINE SOLARANGLE calculates the solar angle
! Originally from Tan's solarangle.F
!------------------------------------------------------------------
      SUBROUTINE SOLARANGLE( DAY, SHOUR, LAT, SIN_solarangle )
        USE parameters
      !
      !
      !   Input:
      !            1) Day of year
      !            2) Latitude
      !            3) Hour
      !
      !   Output: sin of solar angle
      !

      IMPLICIT NONE
      REAL, PARAMETER :: PI = 3.14159 

      ! Arguments
      INTEGER, INTENT(IN) :: DAY                  ! DOY or julian day
      REAL, INTENT(IN)    :: SHOUR                ! Solar hour
      REAL, INTENT(IN)    :: LAT                  ! Latitude
      REAL, INTENT(OUT)   :: SIN_solarangle

      ! Local scalars
      REAL    :: sindelta, cosdelta, A, B

      ! End header -----------------------------------------------------

      sindelta = -SIN(0.40907) * COS(6.28*(REAL(DAY,KIND(0.))+10.)/365.)
      cosdelta = SQRT(1.-sindelta**2.)

      A = SIN( LAT*D2RAD ) * sindelta
      B = COS( LAT*D2RAD ) * cosdelta

      SIN_solarangle = A + B * COS(2.*PI*(SHOUR-12.)/24.)


      END SUBROUTINE SOLARANGLE


