      subroutine atk(rlat,z,wind,akh,ajnn,lprin)
      implicit double precision (a-h,o-z)
c simple formulation of exchange coefficient following Blackadar

      parameter (nlev=40)    ! number of levels  

      common /cpy/ hcpy,htr,tlai,levcpy,levhtr,zrough,sizelf
      dimension z(nlev),wind(nlev),akm(nlev),akh(nlev)
      common/atmo1/ t(nlev),theta(nlev),p(nlev),rhoair(nlev)
     & ,relh(nlev)
      common/stratpar/ stable,vgday,vgn,zrday,zrn,alphaday,alphan
      logical stable

      dimension ajnn(nlev),akhst(nlev),akmst(nlev)
      logical konv,lprin
      data akm/nlev*0./
c
c  Structure
c
c        z(2)
c         akh(1), z=zm
c        z(1)=0.
c
      
      ak=0.4
      grav=9.81
      airmol=0.1529e-04
      coriol=1./3600./6.*3.1415*sin(rlat)
      thelam=2.7e-04*wind(nlev-1)/coriol
      xx0=0.
      xxh=0.

      do k=1,nlev
      theta(k)=t(k)*((100000.0/p(k))** .286)
      rhoair(k)=p(k)/287./t(k)
      im=max(k-1,1)
      ip=min(k+1,nlev)
      akhst(k)=0.05*akh(k)+0.90*akh(im)+0.05*akh(ip)+airmol
      akmst(k)=0.05*akm(k)+0.90*akm(im)+0.05*akm(ip)+airmol
      enddo

      xx0=0.
      do k=1,nlev-1
      im=max(k-1,1)
      ip=min(k+1,nlev)
      dz=z(k+1)-z(k)
      strat=(theta(k+1)-theta(k))/dz
      if(k.ge.levcpy) then
      if(strat.le.0.0) then
      xx0=xx0+(z(ip)-z(k))
      konv=(theta(k)+0.1).lt.theta(1)
      if(konv) then
      if(xxh.le.0.) xxh=z(k)
      endif
      else
      konv=.false.
      endif
      endif
      enddo

      if(lprin) write(6,'(/,"xx0,xxh",2f8.1)') xx0,xxh
      if(lprin) then 
      write(6,'("  k      zm      strat      vzbet         ri    ",     
     &"    xlam       ajnn        akm         akh")')
      endif

      do k=1,nlev-1
      dz=z(k+1)-z(k)
      strat=(theta(k+1)-theta(k))/dz
      vzbet=(wind(k+1)-wind(k))/dz
      zm=0.5*(z(k)+z(k+1))
      tm=0.5*(t(k)+t(k+1))
      vzbet2=vzbet*vzbet
      ri=grav*strat/(tm*vzbet2)

      xlam=dmax1(thelam,.1*xx0,.10*xxh) 

      if(zm.gt.dmax1(xx0,xxh)) xlam=thelam
      all=ak*zm/(1.0+ak*zm/xlam)

      if (k.lt.levcpy) then
       xlam=2.
      all=ak*zm/(1.0+ak*zm/xlam)
      else
      if(zm.gt.dmax1(xx0,xxh)) xlam=thelam
      all=ak*(zm-0.85*hcpy)/(1.0+ak*(zm-0.85*hcpy)/xlam)
      endif

      ajnn(k)=(all**2)*sqrt(vzbet2) 

      if(ri.lt.0.) then
      akm(k)=ajnn(k) * sqrt(1.-11.*ri) +airmol
      akh(k)=akm(k) * 1.35*(1.-5.5*ri)/(1.-3.*ri) +airmol
      else
      ri=min(ri,1.0)
      akm(k)=ajnn(k)  / sqrt(1.+6.*ri) +airmol
      if(stable) then
!x      akh(k)=akm(k) * 1.35/(1.+6.*ri) +airmol
      akh(k)=akm(k) * 1.35/(1.+6.*ri) +airmol
!      if(timeloc.gt.18.or.timeloc.lt.5)
!     &  akh(k)=2*(akm(k) * 1.35/(1.+6.*ri) +airmol)
      else
      akh(k)=akm(k)
      endif
c              ----------------------------------------
      endif
c smoothing
      akm(k)=0.1*akmst(k)+0.9*akm(k)
      akh(k)=0.1*akhst(k)+0.9*akh(k)
      if(lprin) then 
      write(6,'(i3,f9.2,9e12.4)') 
     &   k,zm,strat,vzbet,ri,all,ajnn(k),akm(k),akh(k)        
      endif
      enddo

      if(lprin) then 
c     write(6,'(/,"  k      zm      strat      vzbet         ri    ",     
c    &"   ajnn       akm        akh")') 
      do k=nlev-1,1,-1
      zm=0.5*(z(k)+z(k+1))
      strat=(theta(k+1)-theta(k))/dz
      vzbet=(wind(k+1)-wind(k))/dz
c     if(z(k).gt.30.) vzbet=0.4/(zm-27.)
      vzbet2=vzbet*vzbet
      ri=grav*strat/(tm*vzbet2)
c     write(6,'(i3,f9.2,7e12.4)') 
c    &   k,zm,strat,vzbet,ri,ajnn(k),akm(k),akh(k)        
c     ajnn(k)=ajnn(10)
      enddo
      endif

      return
      end


      subroutine solve(ab,bb,db,at,bt,dt,a,b,c,d,var,nr)
      implicit double precision (a-h,o-z)
      save
c
c      solve tridiagonal system to calculate new values (atmosphere)
c
      parameter(nlev=40)
      dimension a(nlev),b(nlev),c(nlev),d(nlev),
     &alpha(nlev),beta(nlev),xx(nlev),var(nlev)
      alpha(nr)=-bb/ab
      beta(nr)=db/ab
      m1=nlev-1
      do 4 j=nr+1,m1
      xx(j)=(a(j)*alpha(j-1)+b(j))
c     write(06,'("  solve ", i3, 8e11.4)') j,xx(j),a(j),b(j),
c    & alpha(j-1),beta(j-1)
      alpha(j)=-c(j)/xx(j)
   4  beta(j)=-(a(j)*beta(j-1)-d(j))/xx(j)
      var(nlev)=(dt-at*beta(m1))/(bt+alpha(m1)*at)
      do 5 jj=nr,m1
      j=nlev-jj
      var(j)=var(j+1)*alpha(j)+beta(j)
      if(var(j).lt.0.) var(j)=.0001*var(j+1)
   5  continue
      if(nr.eq.1)return
      l=nr-1
      do 7 i=1,l
   7  var(i)=var(nr)
      return
      end


c *********************************************************************

      subroutine newt(akh)                                               
      use parameters
      implicit double precision (a-h,o-z)
      save
      parameter(nlev=40)

!x      common/timpar/timloc,deltim,month,jday,iyear,icumdy
      common/height/z(nlev),zf(nlev),dz(nlev),dzf(nlev)
      common/grid/ del,zmin1,zmin2,a0(nlev),b0(nlev),c0(nlev)
      common/cpysrc/ evaps(99),heats(99)
      common/rad4/d(3,99),ui(3,99),bmflx(3,99),rnet(99),rndiv(99),
     & tsfc,rnlam(3,99)
      common/atmo1/ t(nlev),theta(nlev),p(nlev),rhoair(nlev)
     & ,relh(nlev)
      dimension akh(nlev),
     & sourct(nlev),x(nlev)

      p0=100000.0

      do k=1,nlev
      theta(k)=t(k)*((p0/p(k))** .286)
      enddo

      do k=2,nlev-1
      rhocp=1200.*p(k)/101300.
c     sourct(k)=0.5*(heats(k)+heats(k-1))/rhocp /dz(k)
      sourct(k)=heats(k-1)/rhocp /dz(k)
c     write(06,'("k,sourct",i3,e12.4)') k,sourct(k)
c 
      a0(k)=-akh(k-1)/dzf(k)/dz(k-1)*deltim
      c0(k)=-akh(k)/dzf(k)/dz(k)*deltim
      b0(k)=1. +(-a0(k)-c0(k))
c
c     deltak=(akh(k)-akh(k-1)) ! ????????????????????????????
c     akhm=0.5*akh(k-1)+0.5*akh(k)
c     s=(k-1)*del
c     yy=zmin1*exp(s)
c     xx=yy+zmin2
c     xdsi=1.0/(xx*xx*del*del)
c     xdsih=0.5*xdsi
c neu
c     a0(k)=( deltak*xdsih-akhm*yy/xx*xdsih-akhm*xdsi)*deltim
c     b0(k)=1.+2.*akhm*xdsi*deltim
c     c0(k)=(-deltak*xdsih+akhm*yy/xx*xdsih-akhm*xdsi)*deltim
CC    write(06,'(i3,8e11.4)')k,deltak,akhm,a0(k),b0(k),c0(k)

      x(k)=theta(k) + ((p0/p(k))**.286)*sourct(k)*deltim 
c     write(06,'(i3,8e12.4)')k,theta(k),x(k)-theta(k)                   
      enddo

c Boundary conditions     
      nr=1
      at=0.0
      bt=1.0
      dt=theta(nlev)
      ab=1.0
      bb=0.0
       db= (tsfc+273.15)*((p0/p(1))**.286)     !preliminary
c Randbedingungen muessen noch verbessert werden >>>>>>>>>>>>>>>>>>>>>>>>
c
c      solve tridiagonal system to calculate new values of theta    
c
c ----------------------------------------------------------------------
      call solve(ab,bb,db,at,bt,dt,a0,b0,c0,x,theta,nr)
c ----------------------------------------------------------------------

      do k=1,nlev
       t(k)=theta(k)/((100000.0/p(k))** .286)
      enddo

      return
      end

c *********************************************************************

      subroutine newc(akh,vcp)
      use parameters
      implicit double precision (a-h,o-z)
      save
      parameter(nlev=40)
      parameter(maxrect=500)
      parameter (nspec=77, nrect=237)

!x      common/timpar/timloc,deltim,month,jday,iyear,icumdy
      common/height/z(nlev),zf(nlev),dz(nlev),dzf(nlev)
      common/atmo1/ t(nlev),theta(nlev),p(nlev),rhoair(nlev)
     & ,relh(nlev)
      common/grid/ del,zmin1,zmin2,a0(nlev),b0(nlev),c0(nlev)
      common/quellen/source(nlev,nspec)
      common/spezies/
     &    LACO3, LADDC, LADDT, LADDX, LALD , LAPI , LAPIP, LCH4,
     &    LCO  , LCO2 , LCSL , LCSLP, LDCB , LDIEN, LETE , LETEP,
     &    LETH , LETHP, LGLY , LH2  , LH2O , LH2O2, LHC3 , LHC3P,
     &    LHC5 , LHC5P, LHC8 , LHC8P, LHCHO, LHKET, LHNO3, LHNO4,
     &    LHO  , LHO2 , LHONO, LISO , LISOP, LKET , LKETP, LLIM,
     &    LLIMP, LMACR, LMGLY, LMO2 , LN2  , LN2O5, LNO  , LNO2,
     &    LNO3 , LO1D , LO2  , LO3  , LO3P , LOLI , LOLIP, LOLND,
     &    LOLNN, LOLT , LOLTP, LONIT, LOP1 , LOP2 , LORA1, LORA2,
     &    LPAA , LPAN , LPHO , LSO2 , LSULF, LTCO3, LTOL , LTOLP,
     &    LTPAN, LUDD , LXO2 , LXYL , LXYLP



      dimension akh(nlev), vcp(nlev,nspec)
      dimension x(nlev),cs(nlev)

c Turbulent transport with simple implicit scheme
c Water vapor already included
 
      do k=2,nlev-1
c alt
      a0(k)=-akh(k-1)/dzf(k)/dz(k-1)*deltim
      c0(k)=-akh(k)/dzf(k)/dz(k)*deltim
      b0(k)=1.+(-a0(k)-c0(k))
c
      deltak=(akh(k)-akh(k-1)) ! ????????????????????????????
      akhm=0.7*akh(k-1)+0.3*akh(k)
      s=(k-1)*del
      yy=zmin1*exp(s)
      xx=yy+zmin2
      xdsi=1.0/(xx*xx*del*del) 
      xdsih=0.5*xdsi
c neu (da ist wohl noch ein Fehler drin)
c     a0(k)=( deltak*xdsih-akhm*yy/xx*xdsih-akhm*xdsi)*deltim
c     b0(k)=1.+2.*akhm*xdsi*deltim
c     c0(k)=(-deltak*xdsih+akhm*yy/xx*xdsih-akhm*xdsi)*deltim
c     write(06,'(i3,8e11.4)')k,deltak,akhm,a0(k),b0(k),c0(k)
      enddo

      do 20 jspec=1,nspec                ! species loop for transport
      do k=1,nlev
c      cs(k)=vcp(k,jspec) *rhoair(k)
       cs(k)=vcp(k,jspec)
      enddo

      do k=2,nlev-1
c     if(jspec.eq.lh2o) then
      x(k)=cs(k)  + source(k,jspec)*deltim 
c     else
c     x(k)=cs(k) 
c     endif
      enddo

      at=0.0
      bt=1.0
      dt=cs(nlev)
c Lower boundary at soil surface
      ab=1.0
      bb=0.0
      db=cs(2)  + source(1,jspec)*deltim     !preliminary
      if(jspec.eq.lh2o) db=cs(1)  ! Damit Grenzfl. beruecksichtigt wird!
c Randbedingungen muessen noch verbessert werden >>>>>>>>>>>>>>>>>>>>>>>>
 
      nr=1
c ----------------------------------------------------------------------
      if(jspec.ne.lo3p) then ! O3P leads to time-step problems if transported
      call solve(ab,bb,db,at,bt,dt,a0,b0,c0,x,cs,nr)
      endif
c ----------------------------------------------------------------------
 
 
      do k=1,nlev
       if(cs(k).lt.-1.e-15) write(06,'(" cs < 0. ",2i3,e12.4)')
     & jspec, k, cs(k)
c      vcp(k,jspec)=max(cs(k)/rhoair(k),0.)
       vcp(k,jspec)=max(cs(k),0.)
      enddo
 
  20  continue                                 ! Ende species loop

      return
      end

